package spads1;

// Class created by Simon Dellicour (july 2011)

import java.util.ArrayList;

public class Barrier 
{
	private InputFileReader input;
	public ArrayList<Integer> popID;
	public ArrayList<String> results;
	public ArrayList<String> externalMessage;
	public SimThread simTestThread;
	
	public Barrier(InputFileReader input0, Interface window, SimThread simTestThread0)
		{
			simTestThread = simTestThread0;
			simTestThread.run("Beginning of locus by locus Monmonier algorithm");
			
			input = input0;
			// Amova amova = new Amova();
			results = new ArrayList<String>();
			externalMessage = new ArrayList<String>();
			double B = 0; // number of barriers to construct (defined by the user)
			int Bmin = 1;
			if (input.minimumNumberOfBarriers > 0)
				{
					Bmin = (int) input.minimumNumberOfBarriers;
				}
			B = input.maximumNumberOfBarriers;
			
			// Creation of the "PopID" ArrayList:
			ArrayList<Node> nodes = new ArrayList<Node>();
			for (int i = 0; i < input.loci.get(0).populations.size(); i++)
				{
					nodes.addAll(input.loci.get(0).populations.get(i).nodes);
				}
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes.get(0).currentPop));
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).currentPop == nodes.get(j).currentPop)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes.get(i).currentPop)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's.
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}
			
			if (input.pairwiseMonmonierDistances == false)
				{
					results.add("Monmonier algorithm RESULTS (locus by locus): ");
					results.add("	the different inferred barriers defined groups of populations.");
					results.add("	The corresponding group ID for each population are reported below.");
					results.add("");
				}
			for (int h = 0; h < input.numberOfLoci; h++)
				{
					boolean startMonmonier = true;
					if (input.pairwiseMonmonierDistances == true)
						{
							results.add("Monmonier algorithm RESULTS (based on an external distance matrix): ");
							results.add("	the different inferred barriers defined groups of populations.");
							results.add("	The corresponding group ID for each population are reported below.");
							results.add("");
							input.loci.get(h).monmonierDistances = new double[input.loci.get(h).populations.size()][input.loci.get(h).populations.size()];
							for (int i = 0; i < input.loci.get(h).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(h).populations.size(); j++)
										{
											input.loci.get(h).monmonierDistances[i][j] = input.monmonierDistances[i][j];
											input.loci.get(h).monmonierDistances[j][i] = input.monmonierDistances[j][i];   
										}
								}
							if (h > 0)
								{
									startMonmonier = false;
								}
						}
					if (startMonmonier == true)
						{
							boolean fstMatrix = false;
							if (input.pairwiseMonmonierDistances == false)
								{
									results.add("LOCUS " + input.loci.get(h).ID);
								}
							String popNamesString = new String();
							for (int k0 = 0; k0 < popID.size(); k0++)
								{
									popNamesString = popNamesString + input.loci.get(h).populations.get(k0).popName + "	";
								}
							results.add("Clusters ID	" + popNamesString);
							
							for (int currentB = Bmin; currentB < (B+1); currentB++)
								{
									String Gs = new String();
									int[][] delaunayTriangulation = new int[input.loci.get(h).populations.size()][input.loci.get(h).populations.size()];
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < input.loci.get(h).populations.size(); j++)
												{
													delaunayTriangulation[i][j] = input.loci.get(h).delaunayTriangulation[i][j];
												}
										}
									
									nodes = new ArrayList<Node>();
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											nodes.addAll(input.loci.get(h).populations.get(i).nodes);
										}
									
									double highestFst = -2;
									for (int b = 0; b < currentB; b++)							
										{
											highestFst = -2;
											int[][] initialBarrier0 = new int[1][2];
											// Finding the (b+1)eme highest Fst between 2 sampled populations:
											for (int i = 1; i < input.loci.get(h).populations.size(); i++)
												{
													for (int j = 0; j < i; j++)
														{
															double fst = input.loci.get(h).monmonierDistances[i][j];
															if (delaunayTriangulation[i][j] == 1 && highestFst < fst)
																{
																	highestFst = fst;
																	initialBarrier0[0][0] = i; initialBarrier0[0][1] = j;
																}
														}
												}
											delaunayTriangulation[initialBarrier0[0][0]][initialBarrier0[0][1]] = -1;
											delaunayTriangulation[initialBarrier0[0][1]][initialBarrier0[0][0]] = -1;	
											
											for (int f = 0; f < 2; f++)
												{
													// System.out.print("Sense " + (f+1) + ":        ");
													ArrayList<Integer> barrierPops = new ArrayList<Integer>();
													Integer int1 = new Integer(input.loci.get(h).populations.get(initialBarrier0[0][0]).popID); barrierPops.add(int1);
													Integer int2 = new Integer(input.loci.get(h).populations.get(initialBarrier0[0][1]).popID); barrierPops.add(int2);	
													int[][] initialBarrier = new int[1][2];
													initialBarrier[0][0] = initialBarrier0[0][0];
													initialBarrier[0][1] = initialBarrier0[0][1];
													int[][] barrier = new int[1][2];
													int[][] lastBarrier = new int[1][2];
													lastBarrier[0][0] = -1; lastBarrier[0][1] = -1;
													
													for (int i = 0; i < (input.loci.get(h).populations.size()*input.loci.get(h).populations.size()); i++)
														{	
															double d1 = 0; // double d2 = 0;		
															// In case of a triangle (see archive to get a code in a case of a square):
															double c1 = 0;
															for (int j = 0; j < input.loci.get(h).populations.size(); j++)
																{	
																	double c2 = 0;
																	if (delaunayTriangulation[initialBarrier[0][0]][j] == 1
																		&& delaunayTriangulation[initialBarrier[0][1]][j] == 1
																		&& c1 == 0)
																		{
																			c1 = c1 + 1;
																			double fst1 = input.loci.get(h).monmonierDistances[initialBarrier[0][0]][j];
																			double fst2 = input.loci.get(h).monmonierDistances[initialBarrier[0][1]][j];
																			if ((fst1 < fst2) | Double.isNaN(fst1))
																				{
																					barrier[0][0] = initialBarrier[0][1]; barrier[0][1] = j;
																					c2 = c2 + 1;	
																				}
																			else if ((fst2 < fst1) | Double.isNaN(fst2))
																				{
																					barrier[0][0] = initialBarrier[0][0]; barrier[0][1] = j;
																					c2 = c2 + 1;
																				}
																			else if ((fst1 == fst2) | (Double.isNaN(fst1) & Double.isNaN(fst2)))
																				{
																					double r = Math.random();
																					if (r < 0.5)
																						{	barrier[0][0] = initialBarrier[0][0]; barrier[0][1] = j;	}
																					else {	barrier[0][0] = initialBarrier[0][1]; barrier[0][1] = j;	}
																					c2 = c2 + 1;
																				}	
																		}
																	if (c2 > 0)
																		{	
																			lastBarrier[0][0] = initialBarrier[0][0]; lastBarrier[0][1] = initialBarrier[0][1];
																			initialBarrier[0][0] = barrier[0][0]; initialBarrier[0][1] = barrier[0][1];
																			d1 = d1 + 1;
																		}
																}
															if (d1 == 1)
																{
																	delaunayTriangulation[initialBarrier[0][0]][initialBarrier[0][1]] = -1;
																	delaunayTriangulation[initialBarrier[0][1]][initialBarrier[0][0]] = -1;
																	// System.out.println(input.loci.get(h).populations.get(initialBarrier[0][0]).popID + " - " + input.loci.get(h).populations.get(initialBarrier[0][1]).popID);
																	Integer newInt = new Integer(input.loci.get(h).populations.get(initialBarrier[0][1]).popID); barrierPops.add(newInt);
																}
														}
												}
										}	
									
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											input.loci.get(h).populations.get(i).barrierGroupID = -1;
										}
									ArrayList<Group> finalGroups = new ArrayList<Group>();
									int id = 0;	
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											if (input.loci.get(h).populations.get(i).barrierGroupID == -1)
												{
													id = id + 1;
													input.loci.get(h).populations.get(i).barrierGroupID = id;
													Double ID = new Double(id); String groupName = new String(); groupName = ID.toString();
													
													ArrayList<Integer> groupPopulations = new ArrayList<Integer>();
													Group group = new Group(id, groupName);
													Integer a = new Integer(i); groupPopulations.add(a);
													group.populations.add(input.loci.get(h).populations.get(i));
													
													for (int k = 0; k < groupPopulations.size(); k++)
														{
															for (int j = 0; j < input.loci.get(h).populations.size(); j++)
																{
																	if (delaunayTriangulation[groupPopulations.get(k)][j] == 1
																		&  input.loci.get(h).populations.get(j).barrierGroupID == -1)
																		{
																			Integer b = new Integer(j); groupPopulations.add(b);
																			group.populations.add(input.loci.get(h).populations.get(j));
																			input.loci.get(h).populations.get(j).barrierGroupID = id;
																			// System.out.println("Connexion between " + input.loci.get(h).populations.get(groupPopulations.get(k)).popID + " and " + input.loci.get(h).populations.get(j).popID);
																		}
																	if (delaunayTriangulation[groupPopulations.get(k)][j] == -1)
																		{
																			// System.out.println("Barrier between " + input.loci.get(h).populations.get(groupPopulations.get(k)).popID + " and " + input.loci.get(h).populations.get(j).popID);
																		}
																}
														}
													finalGroups.add(group);
												}
											// System.out.println();
										}							
									
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											Gs = Gs + input.loci.get(h).populations.get(i).barrierGroupID + "	";
										}
									
									// To print a pairwise Fst matrix between all the sampled populations:
									if (fstMatrix == false)
										{
											externalMessage.add("Fst matrix between all the sampled populations for locus " + input.loci.get(h).ID + ": ");
											externalMessage.add("");
											for (int i = 0; i < input.loci.get(h).populations.size(); i++)
												{
										 			String line = new String();
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
													 	{
														 	if (i != j)
														 		{
														 			double fst = input.loci.get(h).monmonierDistances[i][j];
																	line = line + fst + "	";
														 		}	
														 	else
															 	{
														 			line = line + 0 + "	";
															 	}		
													 	} 
													externalMessage.add(line);
												}	externalMessage.add("");
											fstMatrix = true;	
										}
									
									/* Construction of the barriers matrix:
									externalMessage.add("Barriers matrix (locus by locus Monmonier algorithm) for locus " + (h+1) + " for B = " + currentB + " (-1 corresponds to a barrier between two sampled populations): ");
									String popID1 = new String();
									ArrayList<String> popID2 = new ArrayList<String>();
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											popID1 = popID1 + input.loci.get(h).populations.get(i).popName + "	";
											popID2.add(input.loci.get(h).populations.get(i).popName);
											//popID2.add(String.valueOf(input.loci.get(h).populations.get(i).popID));
										}
									externalMessage.add("	" + popID1);
									externalMessage.add("	");						
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{	
											String line = new String();
											line = (popID2.get(i) + "	");
											for (int j = 0; j < input.loci.get(h).populations.size(); j++)
												{
													line = line + (delaunayTriangulation[i][j] + "	");
												}	externalMessage.add(line);
										}	externalMessage.add("	"); //*/
									
									results.add("for B = " + currentB + ":	" + Gs);
									results.add("");
									if (input.pairwiseMonmonierDistances == false)
										{
											/* double[] Fstats = new double[6]; Fstats = amova.amova(h, input.loci.get(h), finalGroups, nodes, 0, simTestThread);
											double Fct = 0; Fct = Fstats[2];
											double Fst = 0; Fst = Fstats[1];
											double Fsc = 0; Fsc = Fstats[0];
											results.add("     Fct: " + "	" + Fct);
											results.add("     Fst: " + "	" + Fst);
											results.add("     Fsc: " + "	" + Fsc); */
											simTestThread.run("End of Monmonier algorithm for B = " + currentB + ", locus " + (h+1));
										}
									else
										{
											simTestThread.run("End of Monmonier algorithm for B = " + currentB);
										}		
								}
							simTestThread.run("	for locus " + (h+1));
							simTestThread.run("End of locus by locus Monmonier algorithm");
						}
				}
			results.add("Users are strongly advised to enter the pairwise distance matrices produced by SPADS in the BARRIER software developped by Manni et al (2004).");
			results.add("In addition to display the Vorono polygonation used by the algorithm, this software provides a useful graphical representation of the different ");
			results.add("	barriers inferred by a similar Monmonier algorithm.");
		}
}
