package spads1;

// Class created by Simon Dellicour with Google Web Toolkit (June 2011)

import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;
import java.awt.Color;
import javax.swing.SwingConstants;
import java.awt.Font;
import javax.swing.JTextArea;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import javax.swing.JCheckBox;

public class InterfaceNew extends JFrame 
{
	private static final long serialVersionUID = 1L;
	public MessageConsole mc;
	public JTextArea progressionTextArea;
	private JTextField inputFolderName;
	private JTextField numberOfUserGroups;
	private JTextField minimumNumberOfSamovaGroups;
	public JButton buttonStart = null;
	private JButton buttonStop = null;
	private JTextField numberOfLoci;
	private JTextField samovaNumberOfIterations;
	private JTextField samovaNumberOfRepetitions;
	private JTextField maximumNumberOfSamovaGroups;
	public JCheckBox checkBoxNhtot;
	public JCheckBox checkBoxGstNst;
	public JCheckBox checkBoxFst;
	public JCheckBox checkBoxIBDSC;
	public JCheckBox checkBoxmFstdgeo;
	public JCheckBox checkBoxXh;
	public JCheckBox checkBoxPi;
	public JCheckBox checkBoxPirs;
	public JCheckBox checkBoxAr;
	public JCheckBox checkBoxPairwiseFst;
	public JCheckBox checkBoxAMOVA;
	public JCheckBox checkBoxSpagedi;
	public JCheckBox checkBoxStructure;
	public JCheckBox checkBoxBAPS;
	public JCheckBox checkBoxGeneland;
	public JCheckBox checkBoxGDPAL;
	public JCheckBox checkBoxSamova;
	public JCheckBox checkBoxMonmonier;
	private JTextField permutationsGstNst;
	private JTextField permutationsFst;
	private JTextField permutationsPairwiseFst;
	private JTextField permutationsAMOVA;
	public String inputNameText1; // input directory
	public String inputNameText2; // input name
	private JTextField inputFileName;
	
	public InterfaceNew() 
		{
			setResizable(false);
			getContentPane().setBackground(Color.WHITE);
			setTitle("SPADS 1.0");
			setSize(628, 678);
			getContentPane().setLayout(null);
			
			setIconImage(new ImageIcon(getClass().getResource("/images/SPADS mug.jpeg")).getImage());
			
			JLabel logo = new JLabel("");
			logo.setIcon(new ImageIcon(InterfaceNew.class.getResource("/images/SPADS mug.jpeg")));
			logo.setBounds(453, 468, 154, 168);
			getContentPane().add(logo);
			
			JLabel lblManualAndExample = new JLabel("Manual and example files: ebe.ulb.ac.be/ebe/Software.html");
			lblManualAndExample.setBounds(21, 32, 283, 16);
			getContentPane().add(lblManualAndExample);
			lblManualAndExample.setFont(new Font("Lucida Grande", Font.PLAIN, 9));
			
			JLabel addressWeb = new JLabel("Dellicour & Mardulyn, 2014, Evolutionary Biology & Ecology");
			addressWeb.setBounds(21, 16, 283, 16);
			getContentPane().add(addressWeb);
			addressWeb.setFont(new Font("Lucida Grande", Font.PLAIN, 9));
			
			JLabel lblIntervalWeight = new JLabel("Number of user-defined groups: ");
			lblIntervalWeight.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblIntervalWeight.setBounds(26, 61, 186, 16);
			getContentPane().add(lblIntervalWeight);
			
			numberOfUserGroups = new JTextField();
			numberOfUserGroups.setFont(new Font("Calibri", Font.PLAIN, 13));
			numberOfUserGroups.setBounds(209, 60, 40, 20);
			getContentPane().add(numberOfUserGroups);
			numberOfUserGroups.setHorizontalAlignment(SwingConstants.CENTER);
			numberOfUserGroups.setText("0");
			numberOfUserGroups.setColumns(10);
			
			JLabel lblNumberOfLoci = new JLabel("Number of loci:");
			lblNumberOfLoci.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblNumberOfLoci.setBounds(26, 85, 93, 16);
			getContentPane().add(lblNumberOfLoci);
			
			numberOfLoci = new JTextField();
			numberOfLoci.setFont(new Font("Calibri", Font.PLAIN, 13));
			numberOfLoci.setBounds(118, 84, 40, 20);
			getContentPane().add(numberOfLoci);
			numberOfLoci.setText("1");
			numberOfLoci.setHorizontalAlignment(SwingConstants.CENTER);
			numberOfLoci.setColumns(10);
			
			JLabel lblSummaryStatisticsOn = new JLabel("Summary statistics on user-defined populations:");
			lblSummaryStatisticsOn.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblSummaryStatisticsOn.setBounds(21, 113, 268, 16);
			getContentPane().add(lblSummaryStatisticsOn);
			
			JLabel lblSummaryStatisticsOn_1 = new JLabel("Summary statistics on user-defined groups:");
			lblSummaryStatisticsOn_1.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblSummaryStatisticsOn_1.setBounds(21, 290, 283, 16);
			getContentPane().add(lblSummaryStatisticsOn_1);
			
			JLabel lblNberOfColumnsinjection = new JLabel("Number of groups (K):");
			lblNberOfColumnsinjection.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblNberOfColumnsinjection.setBounds(365, 43, 131, 16);
			getContentPane().add(lblNberOfColumnsinjection);
			
			minimumNumberOfSamovaGroups = new JTextField();
			minimumNumberOfSamovaGroups.setFont(new Font("Calibri", Font.PLAIN, 13));
			minimumNumberOfSamovaGroups.setBounds(493, 42, 47, 20);
			getContentPane().add(minimumNumberOfSamovaGroups);
			minimumNumberOfSamovaGroups.setHorizontalAlignment(SwingConstants.CENTER);
			minimumNumberOfSamovaGroups.setText("0");
			minimumNumberOfSamovaGroups.setColumns(10);
			
			JLabel lblTo = new JLabel("to");
			lblTo.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblTo.setBounds(545, 43, 22, 16);
			getContentPane().add(lblTo);
			
			maximumNumberOfSamovaGroups = new JTextField();
			maximumNumberOfSamovaGroups.setFont(new Font("Calibri", Font.PLAIN, 13));
			maximumNumberOfSamovaGroups.setBounds(560, 42, 47, 20);
			getContentPane().add(maximumNumberOfSamovaGroups);
			maximumNumberOfSamovaGroups.setText("0");
			maximumNumberOfSamovaGroups.setHorizontalAlignment(SwingConstants.CENTER);
			maximumNumberOfSamovaGroups.setColumns(10);
			
			JLabel lblNumberOfSamova = new JLabel("Number of iterations: ");
			lblNumberOfSamova.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblNumberOfSamova.setBounds(365, 68, 131, 16);
			getContentPane().add(lblNumberOfSamova);
			
			samovaNumberOfIterations = new JTextField();
			samovaNumberOfIterations.setFont(new Font("Calibri", Font.PLAIN, 13));
			samovaNumberOfIterations.setBounds(489, 67, 118, 20);
			getContentPane().add(samovaNumberOfIterations);
			samovaNumberOfIterations.setText("10000");
			samovaNumberOfIterations.setHorizontalAlignment(SwingConstants.CENTER);
			samovaNumberOfIterations.setColumns(10);
			
			JLabel lblNumberOfSamova_1 = new JLabel("Number of repetitions: ");
			lblNumberOfSamova_1.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblNumberOfSamova_1.setBounds(365, 93, 136, 16);
			getContentPane().add(lblNumberOfSamova_1);
			
			samovaNumberOfRepetitions = new JTextField();
			samovaNumberOfRepetitions.setFont(new Font("Calibri", Font.PLAIN, 13));
			samovaNumberOfRepetitions.setBounds(497, 92, 110, 20);
			getContentPane().add(samovaNumberOfRepetitions);
			samovaNumberOfRepetitions.setText("10");
			samovaNumberOfRepetitions.setHorizontalAlignment(SwingConstants.CENTER);
			samovaNumberOfRepetitions.setColumns(10);
			
			JLabel lblNewLabel = new JLabel("Inputs folder:");
			lblNewLabel.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblNewLabel.setBounds(333, 134, 79, 16);
			getContentPane().add(lblNewLabel);
			
			inputFolderName = new JTextField();
			inputFolderName.setFont(new Font("Calibri", Font.PLAIN, 13));
			inputFolderName.setBounds(409, 133, 118, 21);
			getContentPane().add(inputFolderName);
			inputFolderName.setColumns(10);
			
			buttonStart = new JButton("RUN");
			buttonStart.setBounds(539, 159, 66, 20);
			getContentPane().add(buttonStart);
			
			progressionTextArea = new JTextArea();
			progressionTextArea.setBounds(333, 202, 267, 425);
			// progressionTextArea.setOpaque(false);
			getContentPane().add(progressionTextArea);
			progressionTextArea.setFont(new Font("Lucida Grande", Font.PLAIN, 11));
			
			mc = new MessageConsole(progressionTextArea, false);
			
			JLabel label_2 = new JLabel("Number of permutations:");
			label_2.setFont(new Font("Calibri", Font.PLAIN, 13));
			label_2.setBounds(61, 178, 151, 16);
			getContentPane().add(label_2);
			
			permutationsGstNst = new JTextField();
			permutationsGstNst.setFont(new Font("Calibri", Font.PLAIN, 13));
			permutationsGstNst.setText("1000");
			permutationsGstNst.setHorizontalAlignment(SwingConstants.CENTER);
			permutationsGstNst.setColumns(10);
			permutationsGstNst.setBounds(205, 177, 79, 20);
			getContentPane().add(permutationsGstNst);
			
			JLabel label_3 = new JLabel("Number of permutations:");
			label_3.setFont(new Font("Calibri", Font.PLAIN, 13));
			label_3.setBounds(61, 222, 151, 16);
			getContentPane().add(label_3);
			
			permutationsFst = new JTextField();
			permutationsFst.setFont(new Font("Calibri", Font.PLAIN, 13));
			permutationsFst.setText("1000");
			permutationsFst.setHorizontalAlignment(SwingConstants.CENTER);
			permutationsFst.setColumns(10);
			permutationsFst.setBounds(205, 221, 79, 20);
			getContentPane().add(permutationsFst);
			
			JLabel label_4 = new JLabel("Number of permutations:");
			label_4.setFont(new Font("Calibri", Font.PLAIN, 13));
			label_4.setBounds(61, 459, 151, 16);
			getContentPane().add(label_4);
			
			permutationsAMOVA = new JTextField();
			permutationsAMOVA.setFont(new Font("Calibri", Font.PLAIN, 13));
			permutationsAMOVA.setText("1000");
			permutationsAMOVA.setHorizontalAlignment(SwingConstants.CENTER);
			permutationsAMOVA.setColumns(10);
			permutationsAMOVA.setBounds(205, 458, 79, 20);
			getContentPane().add(permutationsAMOVA);
			
			JLabel lblInputFilesConversion = new JLabel("Input files conversion:");
			lblInputFilesConversion.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblInputFilesConversion.setBounds(21, 482, 131, 16);
			getContentPane().add(lblInputFilesConversion);
			
			JLabel lblInputsFolder = new JLabel("Inputs name:");
			lblInputsFolder.setFont(new Font("Calibri", Font.PLAIN, 13));
			lblInputsFolder.setBounds(333, 160, 79, 16);
			getContentPane().add(lblInputsFolder);
			
			inputFileName = new JTextField();
			inputFileName.setFont(new Font("Calibri", Font.PLAIN, 13));
			inputFileName.setColumns(10);
			inputFileName.setBounds(409, 159, 118, 21);
			getContentPane().add(inputFileName);
			
			JButton buttonOpen = new JButton("Open");
			buttonOpen.setBounds(539, 133, 66, 20);
			getContentPane().add(buttonOpen);
			
			checkBoxNhtot = new JCheckBox("total number of haplotypes");
			checkBoxNhtot.setBackground(Color.WHITE);
			checkBoxNhtot.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxNhtot.setBounds(31, 133, 273, 23);
			getContentPane().add(checkBoxNhtot);
			
			checkBoxGstNst = new JCheckBox("Gst, Nst (Pons & Petit, 1995, 1996)");
			checkBoxGstNst.setBackground(Color.WHITE);
			checkBoxGstNst.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxGstNst.setBounds(31, 153, 273, 23);
			getContentPane().add(checkBoxGstNst);
			
			checkBoxFst = new JCheckBox("\u03A6st estimator for K=1 (Excoffier et al, 1992)");
			checkBoxFst.setBackground(Color.WHITE);
			checkBoxFst.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxFst.setBounds(31, 197, 273, 23);
			getContentPane().add(checkBoxFst);
			
			checkBoxIBDSC = new JCheckBox("IBDSC (isolation by distance slope coefficient)");
			checkBoxIBDSC.setBackground(Color.WHITE);
			checkBoxIBDSC.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxIBDSC.setBounds(31, 241, 290, 23);
			getContentPane().add(checkBoxIBDSC);
			
			checkBoxmFstdgeo = new JCheckBox("m\u03A6stdgeo (new statistic for PhyloGeoSim)");
			checkBoxmFstdgeo.setBackground(Color.WHITE);
			checkBoxmFstdgeo.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxmFstdgeo.setBounds(31, 261, 273, 23);
			getContentPane().add(checkBoxmFstdgeo);
			
			checkBoxXh = new JCheckBox("Xh: number of haplotypes ratios");
			checkBoxXh.setBackground(Color.WHITE);
			checkBoxXh.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxXh.setBounds(31, 310, 273, 23);
			getContentPane().add(checkBoxXh);
			
			checkBoxPi = new JCheckBox("Pi: nucleotide diversities (Nei & Li, 1979)");
			checkBoxPi.setBackground(Color.WHITE);
			checkBoxPi.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxPi.setBounds(31, 330, 273, 23);
			getContentPane().add(checkBoxPi);
			
			checkBoxPirs = new JCheckBox("Pir (Mardulyn et al, 2009)");
			checkBoxPirs.setBackground(Color.WHITE);
			checkBoxPirs.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxPirs.setBounds(31, 350, 273, 23);
			getContentPane().add(checkBoxPirs);
			
			checkBoxAr = new JCheckBox("allelic richness (El Mousadik & Petit, 1996)");
			checkBoxAr.setBackground(Color.WHITE);
			checkBoxAr.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxAr.setBounds(31, 370, 273, 23);
			getContentPane().add(checkBoxAr);
			
			checkBoxAMOVA = new JCheckBox("AMOVA \u03A6-statistics (Excoffier et al, 1992)");
			checkBoxAMOVA.setBackground(Color.WHITE);
			checkBoxAMOVA.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxAMOVA.setBounds(31, 434, 273, 23);
			getContentPane().add(checkBoxAMOVA);
			
			checkBoxSpagedi = new JCheckBox("SPAGeDi (Hardy & Vekemans, 2002)");
			checkBoxSpagedi.setBackground(Color.WHITE);
			checkBoxSpagedi.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxSpagedi.setBounds(31, 502, 273, 23);
			getContentPane().add(checkBoxSpagedi);
			
			checkBoxStructure = new JCheckBox("Structure (Pritchard et al, 2000)");
			checkBoxStructure.setBackground(Color.WHITE);
			checkBoxStructure.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxStructure.setBounds(31, 522, 273, 23);
			getContentPane().add(checkBoxStructure);
			
			checkBoxBAPS = new JCheckBox("BAPS (Corander et al, 2003, 2008)");
			checkBoxBAPS.setBackground(Color.WHITE);
			checkBoxBAPS.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxBAPS.setBounds(31, 542, 273, 23);
			getContentPane().add(checkBoxBAPS);
			
			checkBoxGeneland = new JCheckBox("Geneland (Guillot et al, 2005)");
			checkBoxGeneland.setBackground(Color.WHITE);
			checkBoxGeneland.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxGeneland.setBounds(31, 562, 273, 23);
			getContentPane().add(checkBoxGeneland);
			
			checkBoxGDPAL = new JCheckBox("GDisPAL and GDivPAL functions");
			checkBoxGDPAL.setBackground(Color.WHITE);
			checkBoxGDPAL.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxGDPAL.setBounds(31, 602, 273, 23);
			getContentPane().add(checkBoxGDPAL);
			
			checkBoxSamova = new JCheckBox("SAMOVA analysis (Dupanloup et al, 2002):");
			checkBoxSamova.setBackground(Color.WHITE);
			checkBoxSamova.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxSamova.setBounds(324, 15, 283, 23);
			getContentPane().add(checkBoxSamova);
			
			checkBoxMonmonier = new JCheckBox("Barrier (Manni et al, 2004)");
			checkBoxMonmonier.setBackground(Color.WHITE);
			checkBoxMonmonier.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxMonmonier.setBounds(31, 582, 282, 23);
			getContentPane().add(checkBoxMonmonier);
			
			checkBoxPairwiseFst = new JCheckBox("pairwise \u03A6st's (Excoffier et al, 1992)");
			checkBoxPairwiseFst.setFont(new Font("Calibri", Font.PLAIN, 13));
			checkBoxPairwiseFst.setBackground(Color.WHITE);
			checkBoxPairwiseFst.setBounds(31, 390, 273, 23);
			getContentPane().add(checkBoxPairwiseFst);
			
			JLabel label_1 = new JLabel("Number of permutations:");
			label_1.setFont(new Font("Calibri", Font.PLAIN, 13));
			label_1.setBounds(61, 415, 151, 16);
			getContentPane().add(label_1);
			
			permutationsPairwiseFst = new JTextField();
			permutationsPairwiseFst.setText("1000");
			permutationsPairwiseFst.setHorizontalAlignment(SwingConstants.CENTER);
			permutationsPairwiseFst.setFont(new Font("Calibri", Font.PLAIN, 13));
			permutationsPairwiseFst.setColumns(10);
			permutationsPairwiseFst.setBounds(205, 414, 79, 20);
			getContentPane().add(permutationsPairwiseFst);
			
			final JFileChooser fileChooser = new JFileChooser();
			fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			buttonOpen.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent arg0) {
				int returnVal = fileChooser.showOpenDialog(null);
				if (returnVal == JFileChooser.APPROVE_OPTION) 
					{
						File selection = fileChooser.getSelectedFile();
						inputFolderName.setText(selection.getAbsolutePath());
					}
				}
			});
		}
	
	JButton getJButtonStart() 
		{
			return buttonStart;
		}
	JButton getJButtonStop() 
		{
			return buttonStop;
		}
		
	public String getInputName() 
		{
			this.inputNameText1 = new String(); inputNameText1 = inputFolderName.getText();
			this.inputNameText2 = new String(); inputNameText2 = inputFileName.getText();
			String inputNameText = new String();
			if (inputNameText1.length() > 0)
				{
					inputNameText = inputNameText1 + "/" + inputNameText2;
				}
			else
				{
					inputNameText = inputNameText2;
				}
			// System.out.println(inputNameText);
			return inputNameText;
		}
	
	public double getNumberOfUserGroups() 
		{
			String numberOfUserGroups1 = numberOfUserGroups.getText();
			double numberOfUserGroups2 = Double.parseDouble(numberOfUserGroups1);
			return numberOfUserGroups2;
		}
	
	public double getPermutationsGstNst() 
		{
			String permutationsGstNst1 =  permutationsGstNst.getText();
			double permutationsGstNst2 = Double.parseDouble(permutationsGstNst1);
			return permutationsGstNst2;
		}
	
	public double getPermutationsFst() 
		{
			String permutationsFst1 =  permutationsFst.getText();
			double permutationsFst2 = Double.parseDouble(permutationsFst1);
			return permutationsFst2;
		}
	
	public double getPermutationsPairwiseFst() 
		{
			String permutationsPairwiseFst1 =  permutationsPairwiseFst.getText();
			double permutationsPairwiseFst2 = Double.parseDouble(permutationsPairwiseFst1);
			return permutationsPairwiseFst2;
		}
	
	public double getPermutationsAMOVA() 
		{
			String permutationsAMOVA1 =  permutationsAMOVA.getText();
			double permutationsAMOVA2 = Double.parseDouble(permutationsAMOVA1);
			return permutationsAMOVA2;
		}
	
	public double getMinimumNumberOfSamovaGroups() 
		{
			String numberOfSamovaGroups1 = minimumNumberOfSamovaGroups.getText();
			double numberOfSamovaGroups2 = Double.parseDouble(numberOfSamovaGroups1);
			return numberOfSamovaGroups2;
		}
	
	public double getMaximumNumberOfSamovaGroups() 
		{
			String numberOfSamovaGroups1 = maximumNumberOfSamovaGroups.getText();
			double numberOfSamovaGroups2 = Double.parseDouble(numberOfSamovaGroups1);
			return numberOfSamovaGroups2;
		}
	
	public double getSamovaNumberOfIterations() 
		{
			String samovaNumberOfIterations1 = samovaNumberOfIterations.getText();
			double samovaNumberOfIterations2 = Double.parseDouble(samovaNumberOfIterations1);
			return samovaNumberOfIterations2;
		}
	
	public double getSamovaNumberOfRepetitions() 
		{
			String samovaNumberOfRepetions1 = samovaNumberOfRepetitions.getText();
			double samovaNumberOfRepetions2 = Double.parseDouble(samovaNumberOfRepetions1);
			return samovaNumberOfRepetions2;
		}
	
	public double getNumberOfLoci() 
		{
			String numberOfLoci1 = numberOfLoci.getText();
			double numberOfLoci2 = Double.parseDouble(numberOfLoci1);
			return numberOfLoci2;
		}
}
