package spads1;

// Class created by Simon Dellicour (June 2011)

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;

public class MainClass 
{
	public static Interface window;
	public static JButton start;
	public static boolean stop;
	public static ArrayList<String> output;
	public static ArrayList<String> externalMessage;
	public static InputFileReader input;
	public static Thread t;
	public static SimThread simThread;
	
	public static void main(String [] args) throws IOException
		{
			final Interface window = new Interface();
			window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			window.setVisible(true);
			stop = false;
			// window.setIconImage(new ImageIcon("Icon.PNG").getImage());
			start = window.getJButtonStart();
			start.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e) 
						{
							if (stop == true)
								{
									System.out.println("Stopped by user");
									window.buttonStart.setText("Start");
									stop = false;
									Thread.interrupted();
								}
							else
								{
									stop = true;	
									t = new Thread()
										{
											public void run() 
												{
													ArrayList<String> results = new ArrayList<String>();
													externalMessage = new ArrayList<String>();
													results = new ArrayList<String>();
													externalMessage = new ArrayList<String>();
													simThread = new SimThread(window);
													simThread.start();
													
													try {
														simThread.stop("Stop");
														stop = true;
													} catch (InterruptedException e3) {
														// TODO Auto-generated catch block
														e3.printStackTrace();
													}

													simThread.run("Running...");

													try {
															input = new InputFileReader(window, simThread);
														} catch (IOException e2) {
															// TODO Auto-generated catch block
															e2.printStackTrace();
														} catch (InterruptedException e) {
															// TODO Auto-generated catch block
															e.printStackTrace();
														}
													externalMessage.addAll(input.externalMessage);
													// externalMessage.add("End of input file reading.");
													simThread.run("Input file reading");
													
													if (input.inputName.equals("summary_stats_comparison"))
														{
															externalMessage = new ArrayList<String>();
															try {
																SuStsComparison suStsComparison = new SuStsComparison();
																externalMessage.addAll(suStsComparison.externalMessage);
															} catch (IOException e1) {
																e1.printStackTrace();
															}
														}
													else
														{
															SummaryStatistics summaryStatistics = new SummaryStatistics(input, window, simThread);
															results.addAll(summaryStatistics.results);
															externalMessage.addAll(summaryStatistics.externalMessage);
															results.add("");
															try {	
																	if (window.checkBoxSamova.isSelected() & input.minimumNumberOfSamovaGroups > 1)
																		{	
																			Samova samova;
																			try {
																				samova = new Samova(input, window, simThread);
																				results.addAll(samova.results);
																				results.add("");
																				externalMessage.addAll(samova.externalMessage);
																			} catch (InterruptedException e1) {
																				e1.printStackTrace();
																			}
																			
																		}
																	else if (input.minimumNumberOfSamovaGroups == 1)
																		{
																			externalMessage.add("SAMOVA: Kmin has to be at least K=2.");
																			simThread.run("SAMOVA: Kmin has to be at least K=2.");
																		}
																}
															catch (Exception e1) 
																{
																	externalMessage.add("There is a problem with the locus by locus SAMOVA analysis.");
																	simThread.run("   SAMOVA analysis.");
																	simThread.run("There is a problem with the locus by locus");
																}
															
															try {
																	if (window.checkBoxSamova.isSelected() & input.minimumNumberOfSamovaGroups > 1 & input.numberOfLoci > 1)
																		{	
																			if (input.numberOfLoci == 1)
																				{
																					externalMessage.add("The multi-loci SAMOVA analysis requires at least 2 loci.");
																					System.out.println("   requires at least 2 loci.");
																					System.out.println("The multi-loci SAMOVA analysis");
																				}
																			else 
																				{
																					try {
																							Samovam samovam = new Samovam(input, window, simThread);
																							results.addAll(samovam.results);
																							results.add("");
																							externalMessage.addAll(samovam.externalMessage);
																						} catch (InterruptedException e1) {
																							e1.printStackTrace();
																						}											
																				}
																		}
																}
															catch (Exception e1) 
																{
																	externalMessage.add("There is a problem with the multi-loci SAMOVA analysis.");
																	simThread.run("   SAMOVA analysis.");
																	simThread.run("There is a problem with the multi-loci ");
																}
															
															try {
																	if (window.checkBoxMonmonier.isSelected() & input.minimumNumberOfBarriers > 0)
																		{	
																			Barrier barrier = new Barrier(input, window, simThread);
																			results.addAll(barrier.results);
																			results.add("");
																			externalMessage.addAll(barrier.externalMessage);
																		}
																}
															catch (Exception e1) 
																{
																	externalMessage.add("There is a problem with the locus by locus Monmonier algorithm analysis.");
																	simThread.run("   Monmonier algorithm.");
																	simThread.run("There is a problem with the locus by locus ");
																}
															
															try {
																	if (window.checkBoxMonmonier.isSelected() & input.minimumNumberOfBarriers > 0 & input.numberOfLoci > 1)
																		{	
																			Barrierm barrierm = new Barrierm(input, window, simThread);
																			results.addAll(barrierm.results);
																			results.add("");
																			externalMessage.addAll(barrierm.externalMessage);
																		}
																}
															catch (Exception e1) 
																{
																	externalMessage.add("There is a problem with the multi-loci Monmonier algorithm analysis.");
																	simThread.run("   Monmonier algorithm.");
																	simThread.run("There is a problem with the multi-loci ");
																}
														}	
													try {
															if (input.inputName.equals("summary_stats_comparison"))
																{	}
															else
																{
																	FileConversion fileConversion;
																	try {
																			fileConversion = new FileConversion(input, window, simThread);
																			externalMessage.addAll(fileConversion.externalMessage);
																		} catch (IOException e1) {
																			e1.printStackTrace();
																		}				
																}
														}
													catch (Exception e1) 
														{	
															externalMessage.add("There is a problem with the input file conversions.");
															simThread.run("   input file conversions.");
															simThread.run("There is a problem with the ");
														}
													try {
															if (input.inputName.equals("summary_stats_comparison"))
																{	}
															else
																{
																	OutputFileWriter.writeOutput1(results, window.getInputName() + "_results.txt");
																}
														} 
													catch (IOException e1) 
														{
															externalMessage.add("There is a problem with the summary statistics comparison.");
															e1.printStackTrace();
														}
													try {
															OutputFileWriter.writeOutput1(externalMessage, window.getInputName() + "_messages_file.txt");
														} 
													catch (IOException e1) 
														{
															e1.printStackTrace();
														}
													simThread.run("END");
													window.buttonStart.setForeground(Color.BLACK);
													window.buttonStart.setText("Start");
													stop = false;
												}
										};
									t.start();
								}
						}
				});
		}
}
