package spads1;

// Class created by Simon Dellicour (June 2011)

import java.util.ArrayList;

public class OldSuStsClass
{
	public ArrayList<String> results;
	public ArrayList<String> externalMessage;
	public SimThread simTestThread;
	
	public OldSuStsClass(InputFileReader input0, Interface window, SimThread simTestThread0)
		{
			/* input = input0;
			results = new ArrayList<String>();
			results.add("Summary statistics computations: ");
			results.add("");
			externalMessage = new ArrayList<String>();
			simTestThread = simTestThread0;
			
			for (int h = 0; h < input.numberOfLoci; h++)
				{
					results.add("LOCUS " + input.loci.get(h).ID);
					ArrayList<Node> nodes = new ArrayList<Node>();
					for (int i = 0; i < input.loci.get(h).populations.size(); i++)
						{
							nodes.addAll(input.loci.get(h).populations.get(i).nodes);
						}
					
					// (1) Computation of Nhtot:
					double Nh = 0;
					ArrayList<String> differentSequences1 = new ArrayList<String>();
					ArrayList<ArrayList<String>> differentSequences1ArrayList = new ArrayList<ArrayList<String>>();
					try {	
							differentSequences1.add(nodes.get(0).finalSequence);
							differentSequences1ArrayList.add(nodes.get(0).sequence);
							for (int i = 1; i < nodes.size(); i++)
								{
									int a = 0;
									for (int j = 0; j < i; j++)
										{
											if (nodes.get(i).finalSequence.equals(nodes.get(j).finalSequence))
												{
													a = a + 1;
												}
										}
									if (a == 0)
										{
											differentSequences1.add(nodes.get(i).finalSequence);
											differentSequences1ArrayList.add(nodes.get(i).sequence);
										}
								}
							Nh = differentSequences1.size();
							if (window.nhtotButton.isSelected())
								{
									results.add("	Total number of haplotypes: " + (int) Nh);
								}
						}
					catch (Exception e1) 
						{	}
					
					// (2) and (3) estimation of the Gst and Nst statistics (Pons & Petit, 1995, 1996):
					//		cfr. additional notations in green (x, X & deltaX) in the red notebook (29/12/10)
					try {		
							if (window.gstnstButton.isSelected())
								{
									double Gst = this.globalGst(nodes); // to compute the real Gst
									double Nst = this.globalNst(nodes); // to compute the real Nst
									double NstGst = Nst-Gst;
									if (input.permutationsGstNst > 0)
										{
											simTestThread.run("Permutations for Gst & Nst p-value (locus " + (h+1) + ")");
										}
									double pvalGst = 0; double higherOrEqualValuesGst = 0;
									double pvalNst = 0; double higherOrEqualValuesNst = 0;
									double pvalNstGst = 0; double higherOrEqualValuesNstGst = 0;
									for (int i = 0; i < (int) input.permutationsGstNst; i++)
										{
											ArrayList<Node> permutationsNodes = new ArrayList<Node>();
											Permutations permutations = new Permutations();
											permutationsNodes.addAll(permutations.permutationsGlabalGstNstFst(nodes));
											double permutationsGst = this.globalPermutGst(permutationsNodes); // to compute a "permut" Gst
											double permutationsNst = this.globalPermutNst(permutationsNodes); // to compute a "permut" Gst
											double permutationsNstGst = permutationsNst-permutationsGst;
											simTestThread.run("   Locus " + (h+1) + ", Gst, permutation " + (i+1) + "       " + (float) permutationsGst);
											simTestThread.run("   Locus " + (h+1) + ", Nst, permutation " + (i+1) + "       " + (float) permutationsNst);
											if (permutationsGst < Gst)
												{	}
											else
												{
													higherOrEqualValuesGst = higherOrEqualValuesGst + 1;
												}
											if (permutationsNst < Nst)
												{	}
											else
												{
													higherOrEqualValuesNst = higherOrEqualValuesNst + 1;
												}
											if (permutationsNstGst < NstGst)
												{	}
											else
												{
													higherOrEqualValuesNstGst = higherOrEqualValuesNstGst + 1;
												}
										}
									pvalGst = higherOrEqualValuesGst/input.permutationsGstNst;
									pvalNst = higherOrEqualValuesNst/input.permutationsGstNst;
									pvalNstGst = higherOrEqualValuesNstGst/input.permutationsGstNst;
									results.add("	Gst (Pons & Petit, 1995) = " + (float) Gst + "	(p-val = " + pvalGst + ")");
									results.add("	Nst (Pons & Petit, 1996) = " + (float) Nst + "	(p-val = " + pvalNst + ")"); 
									results.add("	Nst-Gst = " + (float) NstGst + "	(p-val = " + pvalNstGst + ")"); 
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the Gst and Nst statistics.");
						}
					
					/* (2, OLD) estimation of the Gst statistics (Pons & Petit, 1995): --> OLD CODE for two independent p-values computations for Gst and Nst. 
					//		cfr. additional notations in green (x, X & deltaX) in the red notebook (29/12/10)
					try {		
							if (window.gstnstButton.isSelected())
								{
									double Gst = this.globalGst(nodes); // to compute the real Gst
									if (input.permutationsGstNst > 0)
										{
											simTestThread.run("Permutations for Gst p-value");
										}
									double pval = 0; double higherOrEqualValues = 0;
									// System.out.println(input.permutationsGstNst);
									for (int i = 0; i < (int) input.permutationsGstNst; i++)
										{
											ArrayList<Node> permutationsNodes = new ArrayList<Node>();
											Permutations permutations = new Permutations();
											permutationsNodes.addAll(permutations.permutationsGlabalGstNstFst(nodes));
											double permutationsGst = this.globalPermutGst(permutationsNodes); // to compute a "permut" Gst
											simTestThread.run("   Gst, permutation " + (i+1) + "	" + (float) permutationsGst);
											if (permutationsGst < Gst)
												{	}
											else
												{
													higherOrEqualValues = higherOrEqualValues + 1;
												}
										}
									pval = higherOrEqualValues/input.permutationsGstNst;
									// double Gst2 = this.globalGst(nodes);
									results.add("	Gst (Pons & Petit, 1995) = " + Gst + "	(p-val = " + pval + ")");
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the Gst statistic.");
						}
					
					// (3, OLD) estimation of the Nst statistics (Pons & Petit, 1996):
					//		cfr. additional notations in green (x, X & deltaX) in the red notebook (29/12/10)
					try {
							if (window.gstnstButton.isSelected())
								{
									double Nst = this.globalNst(nodes); // to compute the real Nst
									if (input.permutationsGstNst > 0)
										{
											simTestThread.run("Permutations for Nst p-value");
										}
									double pval = 0; double higherOrEqualValues = 0;
									for (int i = 0; i < (int) input.permutationsGstNst; i++)
										{
											ArrayList<Node> permutationsNodes = new ArrayList<Node>();
											Permutations permutations = new Permutations();
											permutationsNodes.addAll(permutations.permutationsGlabalGstNstFst(nodes));
											double permutationsNst = this.globalPermutNst(permutationsNodes); // to compute a "permut" Nst
											simTestThread.run("   Nst, permutation " + (i+1) + "	" + (float) permutationsNst);
											if (permutationsNst < Nst)
												{	}
											else
												{
													higherOrEqualValues = higherOrEqualValues + 1;
												}
										}
									pval = higherOrEqualValues/input.permutationsGstNst;
									// double Nst2 = this.globalNst(nodes);
									results.add("	Nst (Pons & Petit, 1996) = " + Nst + "	(p-val = " + pval + ")"); 
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the Nst statistic.");
						}
					
					// (4) estimation of the global Fst statistics for K=1 (Excoffier et al, 1992):
					try {
							if (window.fstK1Button.isSelected()) 
								{
									double Fst = this.globalFst(nodes, (int) input.loci.get(h).length);  // to compute the real Fst
									if (input.permutationsFst > 0)
										{
											simTestThread.run("Permutations for global Fst p-value (locus " + (h+1) + ")");
										}
									double pval = 0; double higherOrEqualValues = 0;
									for (int i = 0; i < (int) input.permutationsFst; i++)
										{
											ArrayList<Node> permutationsNodes = new ArrayList<Node>();
											Permutations permutations = new Permutations();
											permutationsNodes.addAll(permutations.permutationsGlabalGstNstFst(nodes));
											double permutationsFst = this.globalPermutFst(permutationsNodes, (int) input.loci.get(h).length); // to compute a "permut" Fst
											simTestThread.run("   Locus " + (h+1) + ", Fst, permutation " + (i+1) + "       " + (float) permutationsFst);
											if (permutationsFst < Fst)
												{	}
											else
												{
													higherOrEqualValues = higherOrEqualValues + 1;
												}
										}
									pval = higherOrEqualValues/input.permutationsFst;
									// double Fst2 = this.globalFst(nodes, (int) input.loci.get(h).length);
									results.add("	Global Fst for K=1 (Excoffier et al, 1992) = " + (float) Fst + "	(p-val = " + pval + ")");
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the Fst statistic.");
						}
					
					if (input.loci.get(h).userGroups.size() > 0)
						{
							String groupsName = new String();
							for (int i = 0; i < (int) input.loci.get(h).userGroups.size(); i++)
								{
									groupsName = groupsName + input.loci.get(h).userGroups.get(i).name + "	";
								}
							results.add(" ");
							results.add("	User-defined groups:		" + groupsName);
							
							// (5.1) computation of the number of different haplotypes in each user-defined groups (Xhi):
							try {
									if (window.xhsButton.isSelected()) 
										{
											String Nseq = new String();
											String Nhis = new String();
											String Xhis = new String();
							
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													ArrayList<String> differentSequences2 = new ArrayList<String>();
													// System.out.println(input.loci.get(h).userGroups.get(i).name);
													differentSequences2.add(input.loci.get(h).userGroups.get(i).nodes.get(0).finalSequence);
													for (int j = 1; j < input.loci.get(h).userGroups.get(i).nodes.size(); j++)
														{
															int b = 0;
															for (int k = 0; k < j; k++)
																{
																	int a = 0;
																	for (int l = 0; l < input.loci.get(h).userGroups.get(i).nodes.get(j).finalSequence.length(); l++)
																		{
																			if (input.loci.get(h).userGroups.get(i).nodes.get(j).sequence.get(l).equals(input.loci.get(h).userGroups.get(i).nodes.get(k).sequence.get(l)))
																				{	}
																			else {	a = a + 1; }
																		}
																	if (a == 0)
																		{
																			b = b + 1;
																		}
																}
															if (b == 0)
																{
																	differentSequences2.add(input.loci.get(h).userGroups.get(i).nodes.get(j).finalSequence);
																}
														}
													/* if ((differentSequences2.size()/Nh) != 0
															& (differentSequences2.size()/Nh) != 0.1
															& (differentSequences2.size()/Nh) != 0.2
															& (differentSequences2.size()/Nh) != 0.3
															& (differentSequences2.size()/Nh) != 0.4
															& (differentSequences2.size()/Nh) != 0.5
															& (differentSequences2.size()/Nh) != 0.6
															& (differentSequences2.size()/Nh) != 0.7
															& (differentSequences2.size()/Nh) != 0.8
															& (differentSequences2.size()/Nh) != 0.9
															& (differentSequences2.size()/Nh) != 1)
														{
															Nhis = Nhis + differentSequences2.size() + "	";
															Xhis = Xhis + (differentSequences2.size()/Nh) + "	";
														}
													else
														{
															Nseq = Nseq + input.loci.get(h).userGroups.get(i).nodes.size() + "	";
															Nhis = Nhis + differentSequences2.size() + "	";
															Xhis = Xhis + (float) (differentSequences2.size()/Nh) + "	";
														// }
													// Xhis = Xhis + ((differentSequences2.size()/Nh)/input.loci.get(h).userGroups.get(i).surface) + "	";
												}	
											results.add("		Nseq:	" + Nseq);
											results.add("		Nh:	" + Nhis);
											results.add("		Xh:	" + Xhis);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the Xh statistics.");
								}
							
							// (5.2) computation of nucleotidic diversity in each user-defined groups ( or "Pi"):
							try {
									if (window.pisButton.isSelected()) 
										{
											String Pis = new String();
											
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double N = 0;
													double Pi = 0;
													for (int j = 1; j < input.loci.get(h).userGroups.get(i).nodes.size(); j++)
														{
															for (int k = 0; k < j; k++)
																{
																	double a = 0;				
																	double P = 0;
																	N = N + 1;
																	ArrayList<String> sequence1 = new ArrayList<String>();
																	ArrayList<String> sequence2 = new ArrayList<String>();
																	sequence1 = input.loci.get(h).userGroups.get(i).nodes.get(j).sequence;
																	sequence2 = input.loci.get(h).userGroups.get(i).nodes.get(k).sequence;
																	for (int l = 0; l < sequence1.size(); l++)
																		{
																			if (sequence1.get(l).equals(sequence2.get(l)))
																				{	}
																			else 
																				{
																					a = a + 1;
																				}
																		}
																	P = a/((double) sequence1.size());
																	Pi = Pi + P;
																}
														}
													// if (Pi > 0)
														// {
															Pis = Pis + (float) (Pi/N) + "	";
															// }
													// else
														// {
															// Pis = Pis + (Pi/N) + "	";
														// }
													// Pis = Pis + ((Pi/N)/input.loci.get(h).userGroups.get(i).surface) + "	";
												}
											results.add("		Pi:	" + Pis);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the Pi (and PiS) statistics.");
								}
							
							// (5.3) computation of a relative nucleotidic diversity in each user-defined groups (Pir, cfr. notes & Mardulyn et al (2009)
							//		Pir(i) = Pi(i)/Pi(of the "rest" = of the group formed by all the other populations which are not in the considered group)
							try {
									if (window.pirsButton.isSelected()) 
										{
											String Pir = new String();
											double[] Pis = new double[input.loci.get(h).userGroups.size()];
											double[] PiRest = new double[input.loci.get(h).userGroups.size()];
											
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double N = 0;
													double Pi = 0;
													for (int j = 1; j < input.loci.get(h).userGroups.get(i).nodes.size(); j++)
														{
															for (int k = 0; k < j; k++)
																{
																	double a = 0;				
																	double P = 0;
																	N = N + 1;
																	ArrayList<String> sequence1 = new ArrayList<String>();
																	ArrayList<String> sequence2 = new ArrayList<String>();
																	sequence1 = input.loci.get(h).userGroups.get(i).nodes.get(j).sequence;
																	sequence2 = input.loci.get(h).userGroups.get(i).nodes.get(k).sequence;
																	for (int l = 0; l < sequence1.size(); l++)
																		{
																			if (sequence1.get(l).equals(sequence2.get(l)))
																				{	}
																			else 
																				{
																					a = a + 1;
																				}
																		}
																	P = a/((double) sequence1.size());
																	Pi = Pi + P;
																}
														}
													Pis[i] = Pi/N;
													
													ArrayList<Node> rest = new ArrayList<Node> ();
													for (int j = 0; j < input.loci.get(h).userGroups.size(); j++)
														{
															if (input.loci.get(h).userGroups.get(j).groupID != input.loci.get(h).userGroups.get(i).groupID)
																{
																	rest.addAll(input.loci.get(h).userGroups.get(j).nodes);
																}
														}
				
													double NRest = 0;
													double piRest = 0;
													for (int j = 1; j < rest.size(); j++)
														{
															for (int k = 0; k < j; k++)
																{
																	double a = 0;				
																	double P = 0;
																	NRest = NRest + 1;
																	ArrayList<String> sequence1 = new ArrayList<String>();
																	ArrayList<String> sequence2 = new ArrayList<String>();
																	sequence1 = rest.get(j).sequence;
																	sequence2 = rest.get(k).sequence;
																	for (int l = 0; l < sequence1.size(); l++)
																		{
																			if (sequence1.get(l).equals(sequence2.get(l)))
																				{	}
																			else 
																				{
																					a = a + 1;
																				}
																		}
																	P = a/((double) sequence1.size());
																	piRest = piRest + P;
																}
														}
													PiRest[i] = piRest/NRest;
													
													// if ((Pis[i]/PiRest[i]) > 0)
														// {
															Pir = Pir + (float) (Pis[i]/PiRest[i]) + "	";
														// }
													// else
														// {
															// Pir = Pir + (Pis[i]/PiRest[i]) + "	";
														// }
													// Pir = Pir + ((Pis[i]/PiRest[i])/input.loci.get(h).userGroups.get(i).surface) + "	";
												}
											results.add("		Pir:	" + Pir);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the Pir (and PirS) statistics.");
								}
							
							// (5.4) computation of the allelic richness Rg (El Mousadik & Petit, 1996):
							try {
									if (window.arsButton.isSelected())
										{
											String RA = new String();
											// (5.4.1) computation of Ns:
											double Ntot = 0; 
											for (int i = 0; i < input.loci.get(h).populations.size(); i ++)
												{
													if (Ntot < input.loci.get(h).populations.get(i).nodes.size())
														{
															Ntot = input.loci.get(h).populations.get(i).nodes.size();
														}
												}
											double Ns = Ntot;
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double nS = 0;
													for (int j = 0; j < input.loci.get(h).userGroups.get(i).populations.size(); j ++)
														{
															nS = nS + input.loci.get(h).userGroups.get(i).populations.get(j).nodes.size();
														}
													if (nS < Ns)
														{
															Ns = nS;
														}
												}
											// (5.4.1) computation of each Rg:
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double Rg = 0; // allelic richness in group g
													double Ng = 1; // number of individuals in group g
													for (int j1 = 1; j1 < input.loci.get(h).userGroups.get(i).nodes.size(); j1++)
														{
															Ng = Ng + 1; // double b = 0;	
														}
													
													for (int j2 = 0; j2 < Nh; j2++)
														{
															double Pgj = 0;
															double Ngj = 0;
															ArrayList<String> sequence1 = new ArrayList<String>();
															sequence1 = differentSequences1ArrayList.get(j2);
															for (int k = 0; k < Ng; k++)
																{
																	double a = 0;
																	ArrayList<String> sequence2 = new ArrayList<String>();
																	sequence2 = input.loci.get(h).userGroups.get(i).nodes.get(k).sequence;
																	for (int l = 0; l < sequence1.size(); l++)
																		{
																			if (sequence1.get(l).equals(sequence2.get(l)))
																				{	}
																			else 
																				{
																					a = a + 1;
																				}
																		}
																	if (a == 0)
																		{
																			Ngj = Ngj + 1;
																		}
																}
															// System.out.println("Ns = " + Ns);
															// System.out.println("Ng = " + Ng);
															// System.out.println("Ngj = " + Ngj);	
															
															if (Ns <= (Ng - Ngj))
																{
																	double Pgj1 = 0; double Pgj1a = 0; double Pgj1b = 0; double Pgj1c = 0;
																	double Pgj2 = 0; double Pgj2a = 0; double Pgj2b = 0; double Pgj2c = 0;
																	
																	Pgj1a = Ng - Ngj;
																	if ((Ng - Ngj) == 0) {	Pgj1a = 1;	}	
																	for (int k = 1; k < (int) (Ng - Ngj); k++)
																		{
																			Pgj1a = Pgj1a * k;
																		}	// System.out.println("Pgj1a = " + Pgj1a);
																	Pgj1b = Ns;
																	if ((Ns) == 0) {	Pgj1b = 1;	}	
																	for (int k = 1; k < (int) (Ns); k++)
																		{
																			Pgj1b = Pgj1b * k;
																		}	// System.out.println("Pgj1b = " + Pgj1b);
																	Pgj1c = Ng - Ngj - Ns;
																	if ((Ng - Ngj - Ns) == 0) {	Pgj1c = 1;	}	
																	for (int k = 1; k < (int) (Ng - Ngj - Ns); k++)
																		{
																			Pgj1c = Pgj1c * k;
																		}	// System.out.println("Pgj1c = " + Pgj1c);
																	Pgj2a = Ng;
																	if ((Ng) == 0) {	Pgj2a = 1;	}	
																	for (int k = 1; k < (int) (Ng); k++)
																		{
																			Pgj2a = Pgj2a * k;
																		}
																	Pgj2b = Ns;
																	if ((Ns) == 0) {	Pgj2b = 1;	}	
																	for (int k = 1; k < (int) (Ns); k++)
																		{
																			Pgj2b = Pgj2b * k;
																		}
																	Pgj2c = Ng - Ns;
																	if ((Ng - Ns) == 0) {	Pgj2c = 1;	}	
																	for (int k = 1; k < (int) (Ng - Ns); k++)
																		{
																			Pgj2c = Pgj2c * k;
																		}
																	
																	Pgj1 = (Pgj1a/(Pgj1b*Pgj1c)); // System.out.println("Pgj1 = " + Pgj1);
																	Pgj2 = (Pgj2a/(Pgj2b*Pgj2c)); // System.out.println("Pgj2 = " + Pgj2);
																	Pgj = Pgj1/Pgj2; // System.out.println("Pgj = " + Pgj);
																}
															else
																{
																	Pgj = 0;
																}
															Rg = Rg + (1-Pgj); // System.out.println("(1-Pgj) = " + (1-Pgj)); System.out.println();
														}
													RA = RA + (float) Rg + "	"; // System.out.println("Rg = " + Rg); System.out.println();
												}
											results.add("		Ar:	" + RA);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the groups allelic richnesses.");
								}
							
							// (5.5) computation of the AMOVA F-statistics (Excoffier et al, 1992):
							//try {
									if (window.amovaButton.isSelected())
										{
											Amova amova = new Amova();
											ArrayList<Node> nodesInGroups = new ArrayList<Node>();
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i++)
												{
													for (int j = 0; j < input.loci.get(h).userGroups.get(i).populations.size(); j++)
														{
															nodesInGroups.addAll(input.loci.get(h).userGroups.get(i).populations.get(j).nodes);
														}
												}
											double[] Fstats = new double[6]; Fstats = amova.amova(h, input.loci.get(h), input.loci.get(h).userGroups, nodesInGroups, (int) input.permutationsAMOVA, simTestThread);
											double Fct = 0; Fct = Fstats[2]; double pvalFct = 0; pvalFct = Fstats[5];
											double Fst = 0; Fst = Fstats[1]; double pvalFst = 0; pvalFst = Fstats[4];
											double Fsc = 0; Fsc = Fstats[0]; double pvalFsc = 0; pvalFsc = Fstats[3];
											results.add("		AMOVA F-statistics:");
											results.add("		Fsc:   " + (float) Fsc + " (p-val = " + pvalFsc + ")");
											results.add("		Fst:   " + (float) Fst + " (p-val = " + pvalFst + ")");
											results.add("		Fct:   " + (float) Fct + " (p-val = " + pvalFct + ")");
										}
								//}
							//catch (Exception e1) 
								//{	
									//externalMessage.add("There is a problem with the AMOVA analysis.");
								//}
							
							// (5.6) computation of the groups pairwise Fst (Excoffier et al, 1992):
							try {
									externalMessage.add("");
									externalMessage.add("Fst matrix between all groups of populations for locus " + input.loci.get(h).ID + ": ");
									// externalMessage.add("");
									for (int i = 0; i < input.loci.get(h).userGroups.size(); i++)
										{
								 			String line = new String();
											for (int j = 0; j < input.loci.get(h).userGroups.size(); j++)
											 	{
												 	if (i != j)
												 		{
															double fst = this.groupsPairwiseFst(input.loci.get(h), input.loci.get(h).userGroups.get(i),  input.loci.get(h).userGroups.get(j));
															line = line + (float) fst + "	";
															// System.out.println(input.loci.get(h).userGroups.get(i).name + " " + input.loci.get(h).userGroups.get(j).name + " " + fst);
												 		}	
												 	else
													 	{
												 			line = line + 0 + "	";
													 	}		
											 	} 
											externalMessage.add(line);
										}	// externalMessage.add("");
								}
							catch (Exception e1) 
								{	}
						}
					results.add("");
			
					// results.add("	Additionnal summary statistics computed by PhyloGeoSim 1.0: ");
					// (6) estimation of the Dgeo statistics, a new summary statistics (cfr. formula):
					/* try {
							if (window.dgeoButton.isSelected())
								{
									double Dgeo = 0;
									double B = 0;
									ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
									
									// Creation of the "PopID" ArrayList:
									nodes = new ArrayList<Node>();
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											nodes.addAll(input.loci.get(h).populations.get(i).nodes);
										}
									ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
									popID0.add(Integer.valueOf(nodes.get(0).currentPop));
									for (int i = 1; i < nodes.size(); i++)
										{
											int a = 0;
											for (int j = 0; j < i; j++)
												{
													if (nodes.get(i).currentPop == nodes.get(j).currentPop)
														{
															a = a + 1;
														}
												}
											if (a == 0)
												{
													popID0.add(Integer.valueOf(nodes.get(i).currentPop)); 
												}
										}
									int popIDsize = 0; popIDsize = popID0.size(); 
									for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
										{
											int index = 0;
											int bufferID = 0;
											bufferID = popID0.get(0).intValue();
											for (int j = 1; j < popID0.size(); j++)
												{
													if (popID0.get(j).intValue() < bufferID)
														{
															bufferID = popID0.get(j).intValue();
															index = j;
														}
												}
											popID0.remove(index);
											popID.add(bufferID);
										}	
									double n = (double) popID.size();
									
									// computation of B:
									for (int i = 1; i < popID.size(); i ++)
										{
											for (int j = 0; j < i; j ++) // these 2 first lines allow to compute "B" for each pair of sampled populations
												{																																							
													// (1) computation of dgeo:
													double dgeo = 0;
													dgeo = this.populationsDistance(input.loci.get(h).populations, i, j);
									
													// (2) computation of Nk1:
													double Nk1 = 0;
													ArrayList<Node> population1 = new ArrayList<Node>();
													ArrayList<ArrayList<String>> sequencesInPop1 = new ArrayList<ArrayList<String>>();
													for (int k = 0; k < nodes.size(); k++) 
														{
															if (nodes.get(k).currentPop == popID.get(j))
																{
																	Nk1 = Nk1 + 1;
																	population1.add(nodes.get(k));
																	sequencesInPop1.add(nodes.get(k).sequence);
																}
														}
									
													// (3) computation of Nk2:
													double Nk2 = 0;
													ArrayList<Node> population2 = new ArrayList<Node>();
													ArrayList<ArrayList<String>> sequencesInPop2 = new ArrayList<ArrayList<String>>();
													for (int k = 0; k < nodes.size(); k++) 
														{
															if (nodes.get(k).currentPop == popID.get(i))
																{
																	Nk2 = Nk2 + 1;
																	population2.add(nodes.get(k));
																	sequencesInPop2.add(nodes.get(k).sequence);
																}
														} 
									
													// (4) computation of A:
													double A = 0;
													for (int k = 0; k < (int) Nk1; k++)
														{
															for (int l = 0; l < (int) Nk2; l++)
																{
																	double Pij = 0;
																	double a = 0;
																	for (int m = 0; m < input.loci.get(h).length; m++)
																		{
																			if (sequencesInPop1.get(k).get(m).equals(sequencesInPop2.get(l).get(m)) == false)
																				{
																					a = a + 1;
																				}
																		}
																	Pij = (a/input.loci.get(h).length);
																	A = A + Pij;
																}
														}
									
													B = B + (A/(dgeo*Nk1*Nk2));
												}
										}
					
									double n1 = 1; // it will correspond to "n!"
									for (int i = 1; i < (n+1); i++)
										{
											n1 = n1*i;
										}
					
									double n2 = 1; // it will correspond to "(n-2)!"
									for (int i = 1; i < (n+1-2); i++)
										{
											n2 = n2*i;
										}
					
									Dgeo = ((2*n2)/n1)*B;
									results.add("		Dgeo = " + (float) Dgeo);
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the Dgeo statistic.");
						}
					
					// (7) estimation of the mFst/dgeo statistics, a new summary statistics (cfr. formula, mean of the ratios between Fst and geographic distance between populations):
					try {
							if (window.mFstdgeoButton.isSelected())
								{
									double mFstdgeo = 0;
									double a = 0;
									for (int i = 1; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < i; j++)
												{
													a = a + 1;
													double Fst = 0; double dgeo = 0;
													ArrayList<Population> populations0 = new ArrayList<Population>();
													int popID1 = input.loci.get(h).populations.get(i).popID; populations0.add(input.loci.get(h).populations.get(i));
													int popID2 = input.loci.get(h).populations.get(j).popID; populations0.add(input.loci.get(h).populations.get(j));
													Fst = this.populationsFst(input.loci.get(h), populations0, (popID1-1), (popID2-1));
													dgeo = this.populationsDistance(input.loci.get(h).populations, i, j);
													if (Double.isNaN(Fst/dgeo))	{	}
													else 
														{
															mFstdgeo = mFstdgeo + (Fst/dgeo);
														}
												}
										}
									if (a > 0)
										{						
											mFstdgeo = mFstdgeo/a;
											results.add("		mFstdgeo = " + (float) mFstdgeo);
										}
									else 
										{	}
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the mFst/dgeo statistic.");
						}	

					// (8) estimation of the IBD regression slope coefficient (Rousset et al, 1996):
					try {
							if (window.mFstdgeoButton.isSelected())
								{
									double beta1 = 0;
									double n1 = 0;
									for (int i = 1; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < i; j++)
												{
													double Fst = 0;
													ArrayList<Population> populations0 = new ArrayList<Population>();
													int popID1 = input.loci.get(h).populations.get(j).popID; populations0.add(input.loci.get(h).populations.get(j));
													int popID2 = input.loci.get(h).populations.get(i).popID; populations0.add(input.loci.get(h).populations.get(i));
													Fst = this.populationsFst(input.loci.get(h), populations0, (popID1-1), (popID2-1));
													if (Double.isNaN(Fst) | Double.isInfinite((Fst/(1-Fst)))) {	}
													else
														{
															n1 = n1 + 1;
														}						
												}
										}
									double[] x = new double[(int) n1]; double[] y = new double[(int) n1];
									double n2 = 0;
									for (int i = 1; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < i; j++)
												{
													double Fst = 0;
													ArrayList<Population> populations0 = new ArrayList<Population>();
													int popID1 = input.loci.get(h).populations.get(j).popID; populations0.add(input.loci.get(h).populations.get(j));
													int popID2 = input.loci.get(h).populations.get(i).popID; populations0.add(input.loci.get(h).populations.get(i));
													Fst = this.populationsFst(input.loci.get(h), populations0, (popID1-1), (popID2-1));
													if (Double.isNaN(Fst) | Double.isInfinite((Fst/(1-Fst)))) {	}
													else
														{
															x[(int) n2] = Math.log(this.populationsDistance(input.loci.get(h).populations, j, i));
															y[(int) n2] = (Fst/(1-Fst));
															n2 = n2 + 1;
														}						
												}
										}
									LinearRegression regression = new LinearRegression();
									beta1 = regression.Regression(x,y);
									results.add("		IDB regression slope coefficient = " + (float) beta1);
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the IBD regression slope coefficient.");
						}
					
					// (5.7) computation of the distribution of pairwise differences:
					try {
							externalMessage.add("");
							externalMessage.add("Distribution of pairwise differences for locus " + input.loci.get(h).ID + ": ");
				 			String line1 = new String(); String line2 = new String();
				 			int numberOfPairwiseDifferences = 0; double maximumNumberOfPairwiseDifferences = 0;
				 			for (int j = 1; j < nodes.size(); j++)
								{
				 					for (int k = 0; k < j; k++)
										 {
				 							numberOfPairwiseDifferences = numberOfPairwiseDifferences + 1;
										 }
								}
				 			double[] pairwiseDifferences = new double[numberOfPairwiseDifferences];
				 			numberOfPairwiseDifferences = 0;
				 			for (int j = 1; j < nodes.size(); j++)
								{
				 					for (int k = 0; k < j; k++)
										 {
											double a = 0;

											ArrayList<String> sequence1 = new ArrayList<String>();
											ArrayList<String> sequence2 = new ArrayList<String>();
											sequence1 = nodes.get(j).sequence;
											sequence2 = nodes.get(k).sequence;
											for (int l = 0; l < sequence1.size(); l++)
												{
													if (sequence1.get(l).equals(sequence2.get(l)))
														{	}
													else 
														{
															a = a + 1;
														}
												}
											pairwiseDifferences[numberOfPairwiseDifferences] = a;
											numberOfPairwiseDifferences = numberOfPairwiseDifferences + 1;
											if (a > maximumNumberOfPairwiseDifferences)
												{
													maximumNumberOfPairwiseDifferences = a;
												}
										 }		
								}
				 			for (int j = 0; j < (maximumNumberOfPairwiseDifferences+1); j++)
				 				{
				 					line1 = line1 + "	" + j;
				 					int counter = 0;
				 					for (int k = 0; k < pairwiseDifferences.length; k++)
				 						{
				 							if ((int) pairwiseDifferences[k] == j)
				 								{
				 									counter = counter + 1;
				 								}
				 						}
				 					line2 = line2 + "	" + counter;
				 				}
							line1 = "Pairwise differences: " + line1; externalMessage.add(line1); 
							line2 = "Number of occurences: " + line2; externalMessage.add(line2);
						}
					catch (Exception e1) 
						{	}
					
					results.add(" "); // results.add(" ");
					
					// To print a pairwise Fst matrix between all the sampled populations:
					/* System.out.println(); System.out.println("Fst matrix between all the sampled populations: ");
					for (int i = 0; i < input.loci.get(h).populations.size(); i++)
						{
							 for (int j = 0; j < input.loci.get(h).populations.size(); j++)
							 	{
								 	//if (delaunayTriangulation[i][j] != 0)
								 		//{
								 			ArrayList<Population> populations0 = new ArrayList<Population>();
									 		int popID1 = input.loci.get(h).populations.get(i).popID; populations0.add(input.loci.get(h).populations.get(popID1-1));
											int popID2 = input.loci.get(h).populations.get(j).popID; populations0.add(input.loci.get(h).populations.get(popID2-1));
											double fst = this.populationsFst(input.loci.get(h), populations0, (popID1-1), (popID2-1));
											System.out.println(popID1 + " - " + popID2); System.out.println(fst + " ");
											// System.out.print(fst + " ");
								 		//}	
								 	//else
									 	//{
								 			//System.out.print((highestFst-0.1) + " ");
									 	//}		
							 	}			System.out.println();
						}					System.out.println();
				}
		}
	
	// Method to compute the global Gst (Pons & Petit, 1995):
	public double globalGst(ArrayList<Node> nodes)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			double Nh = 0;
			ArrayList<String> differentSequences1 = new ArrayList<String>();
			ArrayList<ArrayList<String>> differentSequences1ArrayList = new ArrayList<ArrayList<String>>();
			differentSequences1.add(nodes.get(0).finalSequence);
			differentSequences1ArrayList.add(nodes.get(0).sequence);
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).finalSequence.equals(nodes.get(j).finalSequence))
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							differentSequences1.add(nodes.get(i).finalSequence);
							differentSequences1ArrayList.add(nodes.get(i).sequence);
						}
				}
			Nh = differentSequences1.size();
			
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes.get(0).currentPop));
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).currentPop == nodes.get(j).currentPop)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes.get(i).currentPop)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}	
			
			ArrayList<Integer> popIDGstNst = new ArrayList<Integer>(); // ArrayList popID's without ID's of populations containing only one individual
			for (int i = 0; i < popID.size(); i++)
				{
					double Nk = 0;
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{
									Nk = Nk + 1;
								}
						}
					if (Nk > 1)
						{
							popIDGstNst.add(popID.get(i));
						}
				}
			
			double X = 0;
			double deltaX = 0;
			double Hk = 0;
			double Hs = 0;				
			double Ht = 0;      
			double Gst = 0;

			// (2.1) computation of Hs:
			for (int i = 0; i < popIDGstNst.size(); i++) // estimation of Hk for each sampled population:
				{
					double Nk = 0; // number of sampled individuals (tip nodes) in the population k. 
					double x = 0; 

					// computation of Nk:
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popIDGstNst.get(i))
								{
									Nk = Nk + 1;
									population.add(nodes.get(j));
								}
						}

					// determination of the different alleles in the considered population: 
					ArrayList<String> differentSequences2 = new ArrayList<String>(); 
					differentSequences2.add(population.get(0).finalSequence);
					for (int j = 1; j < population.size(); j++)
						{
							int a = 0;
							for (int k = 0; k < j; k++)
								{
									if (population.get(j).finalSequence.equals(population.get(k).finalSequence))
										{
											a = a + 1;
										}
								}
							if (a == 0)
								{
									differentSequences2.add(population.get(j).finalSequence);
								}
						}

					// computation of x:
					for (int k = 0; k < differentSequences2.size(); k++)
						{
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(differentSequences2.get(k)))
										{
											Nki = Nki + 1;
										}
								}
							x = x + ((Nki/Nk)*(Nki/Nk));
						}
	
					Hk = (Nk/(Nk-1))*(1-x);
					Hs = Hs + Hk;
				}
			double n = (double) popIDGstNst.size();
			Hs = Hs/n;

			// (2.2) computation of Ht:
			// computation of X:
			for (int i = 0; i < (int) Nh; i++)
				{
					String sequence = new String();
					double Xi = 0;
					sequence = differentSequences1.get(i);
					for (int j = 0; j < popIDGstNst.size(); j++)
						{
							// computation of Nk:
							double Nk = 0;
							ArrayList<Node> population = new ArrayList<Node>();
							for (int k = 0; k < nodes.size(); k++) 
								{
									if (nodes.get(k).currentPop == popIDGstNst.get(j))
										{
											Nk = Nk + 1;
											population.add(nodes.get(k));
										}
								}
							// computation of Nki:
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(sequence))
										{
											Nki = Nki + 1;
										}
								}
							Xi = Xi + (Nki/Nk);
						}
					Xi = Xi/n;
					X = X + (Xi*Xi);
				}
			// computation of deltaX:
			for (int i = 0; i < (int) Nh; i++)
				{
					String sequence = new String();
					double Xki = 0;
					double Xi = 0;
					sequence = differentSequences1.get(i);
					// computation of Xi:
					for (int j = 0; j < popIDGstNst.size(); j++)
						{
							// computation of Nk:
							double Nk = 0;
							ArrayList<Node> population = new ArrayList<Node>();
							for (int k = 0; k < nodes.size(); k++) 
								{
									if (nodes.get(k).currentPop == popIDGstNst.get(j))
										{
											Nk = Nk + 1;
											population.add(nodes.get(k));
										}
								}
							// computation of Nki:
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(sequence))
										{
											Nki = Nki + 1;
										}
								}
							Xi = Xi + (Nki/Nk);
						}
					Xi = Xi/n;

					// computation of Xki:
					for (int j = 0; j < popIDGstNst.size(); j++)
						{
							// computation of Nk:
							double Nk = 0;
							ArrayList<Node> population = new ArrayList<Node>();
							for (int k = 0; k < nodes.size(); k++) 
								{
									if (nodes.get(k).currentPop == popIDGstNst.get(j))
										{
											Nk = Nk + 1;
											population.add(nodes.get(k));
										}
								}
							// computation of Nki:
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(sequence))
										{
											Nki = Nki + 1;
										}
								}
							Xki = Nki/Nk;
							double delta = 0;
							delta = (Xki - Xi);
							deltaX = deltaX + (delta*delta);
						}
				}
			
			Ht = 1 - X + (1/(n*(n-1)))*deltaX;
			Gst = 1 - (Hs/Ht);
			return Gst; 
		}
	
	// Method to compute the global Nst (Pons & Petit, 1996):
	public double globalNst(ArrayList<Node> nodes)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			double Nh = 0;
			ArrayList<String> differentSequences1 = new ArrayList<String>();
			ArrayList<ArrayList<String>> differentSequences1ArrayList = new ArrayList<ArrayList<String>>();
			differentSequences1.add(nodes.get(0).finalSequence);
			differentSequences1ArrayList.add(nodes.get(0).sequence);
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).finalSequence.equals(nodes.get(j).finalSequence))
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							differentSequences1.add(nodes.get(i).finalSequence);
							differentSequences1ArrayList.add(nodes.get(i).sequence);
						}
				}
			Nh = differentSequences1.size();
			
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes.get(0).currentPop));
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).currentPop == nodes.get(j).currentPop)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes.get(i).currentPop)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}	
			
			ArrayList<Integer> popIDGstNst = new ArrayList<Integer>(); // ArrayList popID's without ID's of populations containing only one individual
			for (int i = 0; i < popID.size(); i++)
				{
					double Nk = 0;
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{
									Nk = Nk + 1;
								}
						}
					if (Nk > 1)
						{
							popIDGstNst.add(popID.get(i));
						}
				}
			
			double Nst = 0;
			double Vs = 0;
			double Vt = 0;
			double n = (double) popIDGstNst.size();
			// (3.1) computation of Vs:
			for (int i = 0; i < popIDGstNst.size(); i++)	
				{
					double Vk = 0;
					// computation of Nk:
					double Nk = 0;
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popIDGstNst.get(i))
								{
									Nk = Nk + 1;
									population.add(nodes.get(j));
								}
						} 
					// determination of the different alleles in the considered population: 
					ArrayList<String> differentSequences2 = new ArrayList<String>(); 
					ArrayList<ArrayList<String>> differentSequences2ArrayList = new ArrayList<ArrayList<String>>(); 
					differentSequences2.add(population.get(0).finalSequence);
					differentSequences2ArrayList.add(population.get(0).sequence);
					for (int j = 1; j < population.size(); j++)
						{
							int a = 0;
							for (int k = 0; k < j; k++)
								{
									if (population.get(j).finalSequence.equals(population.get(k).finalSequence))
										{
											a = a + 1;
										}
								}
							if (a == 0)
								{
									differentSequences2.add(population.get(j).finalSequence);
									differentSequences2ArrayList.add(population.get(j).sequence);
								}
						}
	
					// computation of Xx:
					double Xx = 0;
					for (int j = 1; j < differentSequences1.size(); j++)
						{
							for (int k = 0; k < j; k++)
								{
									if (differentSequences1.get(j).equals(differentSequences1.get(k)))
										{	}
									else 
										{
											// computation of Pi:					
											double a = 0;				
											double Pi = 0;
											ArrayList<String> sequence1 = new ArrayList<String>();
											ArrayList<String> sequence2 = new ArrayList<String>();
											sequence1 = differentSequences1ArrayList.get(j);
											sequence2 = differentSequences1ArrayList.get(k);
											for (int l = 0; l < sequence1.size(); l++)
												{
													if (sequence1.get(l).equals(sequence2.get(l)))
														{	}
													else 
														{
															a = a + 1;
														}
												}
											Pi = a/((double) sequence1.size());							
							
											// computation of the first Xki:
											double Nki1 = 0;
											double Xki1 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(j)))
														{
															Nki1 = Nki1 + 1;
														}
												}
											Xki1 = Nki1/Nk;									
							
											// computation of the second Xki:
											double Nki2 = 0;
											double Xki2 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(k)))
														{
															Nki2 = Nki2 + 1;
														}
												}
											Xki2 = Nki2/Nk;				
							
											Xx = Xx + (Pi*Xki1*Xki2);
										}
								}
						}
	
					Vk = (Nk/(Nk-1))*Xx;
					Vs = Vs + Vk;			
				}
			Vs = Vs/n;
	
			// (3.2) computation of Vt:
			double Vt1 = 0;									
			double Vt2 = 0;
			// computation of Vt1:
			for (int j = 1; j < (int) Nh; j++)
				{
					for (int k = 0; k < j; k++)
						{
							if (differentSequences1.get(j).equals(differentSequences1.get(k)))
								{	}
							else 
								{
									// computation of Pi:
									double a = 0;
									double Pi = 0;
									ArrayList<String> sequence1 = new ArrayList<String>();
									ArrayList<String> sequence2 = new ArrayList<String>();
									sequence1 = differentSequences1ArrayList.get(j);
									sequence2 = differentSequences1ArrayList.get(k);
									for (int l = 0; l < sequence1.size(); l++)
										{
											if (sequence1.get(l).equals(sequence2.get(l)))
												{	}
											else 
												{
													a = a + 1;
												}
										}
									Pi = a/((double) sequence1.size());							
				
									// computation of the first X.i:
									double Xi1 = 0;	
									for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
										{
											// computation of Nk:
											double Nk = 0;
											ArrayList<Node> population = new ArrayList<Node>();
											for (int l1 = 0; l1 < nodes.size(); l1++) 
												{
													if (nodes.get(l1).currentPop == popIDGstNst.get(l2))
														{
															Nk = Nk + 1; 
															population.add(nodes.get(l1));
														}
												}																				
											// computation of Nki:
											double Nki = 0;
											for (int l1 = 0; l1 < population.size(); l1++)
												{
													if (population.get(l1).finalSequence.equals(differentSequences1.get(j)))
														{
															Nki = Nki + 1;
														}									
												} 
											Xi1 = Xi1 + (Nki/Nk);
										}
									Xi1 = Xi1/n;												
				
									// computation of the second X.i (X.j):
									double Xi2 = 0;	
									for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
										{
											// computation of Nk:
											double Nk = 0;
											ArrayList<Node> population = new ArrayList<Node>();
											for (int l1 = 0; l1 < nodes.size(); l1++) 
												{
													if (nodes.get(l1).currentPop == popIDGstNst.get(l2))
														{
															Nk = Nk + 1;
															population.add(nodes.get(l1));
														}
												}
											// computation of Nki:
											double Nki = 0;
											for (int l1 = 0; l1 < population.size(); l1++)
												{
													if (population.get(l1).finalSequence.equals(differentSequences1.get(k)))
														{
															Nki = Nki + 1;
														}
												}
											Xi2 = Xi2 + (Nki/Nk);
										}
									Xi2 = Xi2/n;												
				
									Vt1 = Vt1 + (Pi*Xi1*Xi2);
								}
						}
				}
			// computation of Vt2:	
			for (int i = 0; i < popIDGstNst.size(); i++)
				{
					double Vt3 = 0;
					// computation of Nk:
					double Nk = 0;
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popIDGstNst.get(i))
								{
									Nk = Nk + 1;
									population.add(nodes.get(j));
								}
						}
					// determination of the different alleles in the considered population: 
					ArrayList<String> differentSequences2 = new ArrayList<String>(); 
					ArrayList<ArrayList<String>> differentSequences2ArrayList = new ArrayList<ArrayList<String>>(); 
					differentSequences2.add(population.get(0).finalSequence);
					differentSequences2ArrayList.add(population.get(0).sequence);
					for (int j = 1; j < population.size(); j++)
						{
							int a = 0;
							for (int k = 0; k < j; k++)
								{
									if (population.get(j).finalSequence.equals(population.get(k).finalSequence))
										{
											a = a + 1;
										}
								}
							if (a == 0)
								{
									differentSequences2.add(population.get(j).finalSequence);
									differentSequences2ArrayList.add(population.get(j).sequence);
								}
						}
	
					// computation of Vt2:
					for (int j = 1; j < differentSequences1.size(); j++)
						{
							for (int k = 0; k < j; k++)
								{
									if (differentSequences1.get(j).equals(differentSequences1.get(k)))
										{	}
									else 
										{
											// computation of Pi:
											double a = 0;					
											double Pi = 0;
											ArrayList<String> sequence1 = new ArrayList<String>();
											ArrayList<String> sequence2 = new ArrayList<String>();
											sequence1 = differentSequences1ArrayList.get(j);
											sequence2 = differentSequences1ArrayList.get(k);
											for (int l = 0; l < sequence1.size(); l++)
												{
													if (sequence1.get(l).equals(sequence2.get(l)))
														{	}
													else 
														{
															a = a + 1;
														}
												}
											Pi = a/((double) sequence1.size());  
							
											// computation of the first Xki:
											double Nki1 = 0;
											double Xki1 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(j)))
														{
															Nki1 = Nki1 + 1;
														}
												}
											Xki1 = Nki1/Nk;
							
											// computation of the second Xki:
											double Nki2 = 0;
											double Xki2 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(k)))
														{
															Nki2 = Nki2 + 1;
														}
												}
											Xki2 = Nki2/Nk;
							
											// computation of the first X.i:
											double Xi1 = 0;	
											for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
												{
													// computation of Nkk:
													double Nkk = 0;
													ArrayList<Node> populationk = new ArrayList<Node>();
													for (int l1 = 0; l1 < nodes.size(); l1++) 
														{
															if (nodes.get(l1).currentPop == popIDGstNst.get(l2))
																{
																	Nkk = Nkk + 1;
																	populationk.add(nodes.get(l1));
																}
														}
													// computation of Nkki:
													double Nkki = 0;
													for (int l1 = 0; l1 < populationk.size(); l1++)
														{
															if (populationk.get(l1).finalSequence.equals(differentSequences1.get(j)))
																{
																	Nkki = Nkki + 1;
																}
														}
													Xi1 = Xi1 + (Nkki/Nkk);
												}
											Xi1 = Xi1/n;
						
											// computation of the second X.i (X.j):
											double Xi2 = 0;	
											for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
												{
													// computation of Nkk:
													double Nkk = 0;
													ArrayList<Node> populationk = new ArrayList<Node>();
													for (int l1 = 0; l1 < nodes.size(); l1++) 
														{
															if (nodes.get(l1).currentPop == popIDGstNst.get(l2))
																{
																	Nkk = Nkk + 1;
																	populationk.add(nodes.get(l1));
																}
														}
													// computation of Nkki:
													double Nkki = 0;
													for (int l1 = 0; l1 < populationk.size(); l1++)
														{
															if (populationk.get(l1).finalSequence.equals(differentSequences1.get(k)))
																{
																	Nkki = Nkki + 1;
																}
														}
													Xi2 = Xi2 + (Nkki/Nkk);
												}
											Xi2 = Xi2/n;
											Vt3 = Vt3 + (Pi*(Xki1 - Xi1)*(Xki2 - Xi2));
										}
								}						
						}
					Vt2 = Vt2 + Vt3;
				}
			Vt = Vt1 - Vt2*(1/(n*(n-1)));
			Nst = 1 - (Vs/Vt);

			return Nst; 
		}
	
	// Method to compute the global Fst (Excoffier et al, 1992):
	public double globalFst(ArrayList<Node> nodes, int length)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{	
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes.get(0).currentPop));
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).currentPop == nodes.get(j).currentPop)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes.get(i).currentPop)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}	
			
			double Fst = 0;
			int locusLength = length;
			double n = (double) popID.size();
			double SSDwp = 0; // SSD "within populations"
			double SSDap = 0; // SSD "among populations"
			double nPrime = 0; // corresponds to (n')
			double MSDwp = 0; // MSD "within populations"
			double MSDap = 0; // MSD "among populations"
			double Oa = 0; // corresponds to (sigma)a^2
			double Ob = 0; // corresponds to (sigma)b^2
			double O = 0; // corresponds to (sigma)^2
			double N = 0; // number of tip nodes (number of sampled individuals)
			N = nodes.size();
			double ratioSum = 0; // cfr. green anotations
	
			// computation of SSDwp:
			for (int i = 0; i < n; i++)
				{
					double Nki = 0;
					double SSDwpp = 0;
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{	
									Nki = Nki + 1;
									population.add(nodes.get(j));
								}
						}
					for (int j = 0; j < population.size(); j++)
						{
							for (int k = 0; k < population.size(); k++)
								{
									double Pij = 0;
									double a = 0;
									for (int l = 0; l < (int) locusLength; l++)
										{
											if (population.get(j).sequence.get(l).equals(population.get(k).sequence.get(l)) == false)
												{
													a = a + 1;
												}
										}
									Pij = a; //Pij = a/input.getLengthOfTheLocus();
									SSDwpp = SSDwpp + Pij;
								}
						}
					SSDwp = SSDwp + (SSDwpp/(2*Nki));
				}																				
	
			// computation of SSDap:
			double SSDap1 = 0;
			double Nkisum = 0;
			for (int i = 0; i < n; i++)
				{
					double Nki1 = 0;
					ArrayList<Node> population1 = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{	
									Nki1 = Nki1 + 1;
									population1.add(nodes.get(j));
								}
						}
					Nkisum = Nkisum + (2*Nki1);
					for (int j = 0; j < Nki1; j++)
						{
							for (int k = 0; k < n; k++)
								{
									double Nki2 = 0;
									ArrayList<Node> population2 = new ArrayList<Node>();
									for (int l = 0; l < nodes.size(); l++) 
										{
											if (nodes.get(l).currentPop == popID.get(k))
												{	
													Nki2 = Nki2 + 1;
													population2.add(nodes.get(l));
												}
										}
									for (int l = 0; l < Nki2; l++)
										{
											double Pij = 0;
											double a = 0;
											for (int m = 0; m < locusLength; m++)
												{
													if (population1.get(j).sequence.get(m).equals(population2.get(l).sequence.get(m)) == false)
														{
															a = a + 1;
														}
												}
											Pij = a; //Pij = a/input.getLengthOfTheLocus();
											SSDap1 = SSDap1 + Pij;
										}
								}
						}
				}
			SSDap1 = SSDap1/Nkisum;																					
	
			double SSDap2 = 0;
			SSDap2 = SSDwp;
	
			SSDap = SSDap1 - SSDap2;																					
	
			MSDwp = SSDwp/(N - n);																					
			MSDap = SSDap/(n-1);
			
			// computation of n':
			for (int i = 0; i < n; i++)
				{
					double Nki = 0;
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{	
									Nki = Nki + 1;
								}
						}
					ratioSum = ratioSum + ((Nki*Nki)/N);
				}
			nPrime = ((N - ratioSum)/(n-1)); 																					
	
			Ob = MSDwp;																					
			Oa = (MSDap - Ob)/nPrime;																					
			O = Oa + Ob;																					
			Fst = Oa/O;

			return Fst; 
		}
	
	// Method to compute the global Gst (Pons & Petit, 1995) on a permutated dataset:
	// (this method uses the "permutPopID" field instead of the "currentPop" field of the Node objects)
	public double globalPermutGst(ArrayList<Node> nodes)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			double Nh = 0;
			ArrayList<String> differentSequences1 = new ArrayList<String>();
			ArrayList<ArrayList<String>> differentSequences1ArrayList = new ArrayList<ArrayList<String>>();
			differentSequences1.add(nodes.get(0).finalSequence);
			differentSequences1ArrayList.add(nodes.get(0).sequence);
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).finalSequence.equals(nodes.get(j).finalSequence))
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							differentSequences1.add(nodes.get(i).finalSequence);
							differentSequences1ArrayList.add(nodes.get(i).sequence);
						}
				}
			Nh = differentSequences1.size();
			
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes.get(0).permutPopID));
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).permutPopID == nodes.get(j).permutPopID)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes.get(i).permutPopID)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}
			
			ArrayList<Integer> popIDGstNst = new ArrayList<Integer>(); // ArrayList popID's without ID's of populations containing only one individual
			for (int i = 0; i < popID.size(); i++)
				{
					double Nk = 0;
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popID.get(i))
								{
									Nk = Nk + 1;
								}
						}
					if (Nk > 1)
						{
							popIDGstNst.add(popID.get(i));
						}
				}
			
			double X = 0;
			double deltaX = 0;
			double Hk = 0;
			double Hs = 0;				
			double Ht = 0;      
			double Gst = 0;

			// (2.1) computation of Hs:
			for (int i = 0; i < popIDGstNst.size(); i++) // estimation of Hk for each sampled population:
				{
					double Nk = 0; // number of sampled individuals (tip nodes) in the population k. 
					double x = 0; 

					// computation of Nk:
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popIDGstNst.get(i))
								{
									Nk = Nk + 1;
									population.add(nodes.get(j));
								}
						}

					// determination of the different alleles in the considered population: 
					ArrayList<String> differentSequences2 = new ArrayList<String>(); 
					differentSequences2.add(population.get(0).finalSequence);
					for (int j = 1; j < population.size(); j++)
						{
							int a = 0;
							for (int k = 0; k < j; k++)
								{
									if (population.get(j).finalSequence.equals(population.get(k).finalSequence))
										{
											a = a + 1;
										}
								}
							if (a == 0)
								{
									differentSequences2.add(population.get(j).finalSequence);
								}
						}

					// computation of x:
					for (int k = 0; k < differentSequences2.size(); k++)
						{
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(differentSequences2.get(k)))
										{
											Nki = Nki + 1;
										}
								}
							x = x + ((Nki/Nk)*(Nki/Nk));
						}
	
					Hk = (Nk/(Nk-1))*(1-x);
					Hs = Hs + Hk;
				}
			double n = (double) popIDGstNst.size();
			Hs = Hs/n;

			// (2.2) computation of Ht:
			// computation of X:
			for (int i = 0; i < (int) Nh; i++)
				{
					String sequence = new String();
					double Xi = 0;
					sequence = differentSequences1.get(i);
					for (int j = 0; j < popIDGstNst.size(); j++)
						{
							// computation of Nk:
							double Nk = 0;
							ArrayList<Node> population = new ArrayList<Node>();
							for (int k = 0; k < nodes.size(); k++) 
								{
									if (nodes.get(k).permutPopID == popIDGstNst.get(j))
										{
											Nk = Nk + 1;
											population.add(nodes.get(k));
										}
								}
							// computation of Nki:
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(sequence))
										{
											Nki = Nki + 1;
										}
								}
							Xi = Xi + (Nki/Nk);
						}
					Xi = Xi/n;
					X = X + (Xi*Xi);
				}
			// computation of deltaX:
			for (int i = 0; i < (int) Nh; i++)
				{
					String sequence = new String();
					double Xki = 0;
					double Xi = 0;
					sequence = differentSequences1.get(i);
					// computation of Xi:
					for (int j = 0; j < popIDGstNst.size(); j++)
						{
							// computation of Nk:
							double Nk = 0;
							ArrayList<Node> population = new ArrayList<Node>();
							for (int k = 0; k < nodes.size(); k++) 
								{
									if (nodes.get(k).permutPopID == popIDGstNst.get(j))
										{
											Nk = Nk + 1;
											population.add(nodes.get(k));
										}
								}
							// computation of Nki:
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(sequence))
										{
											Nki = Nki + 1;
										}
								}
							Xi = Xi + (Nki/Nk);
						}
					Xi = Xi/n;

					// computation of Xki:
					for (int j = 0; j < popIDGstNst.size(); j++)
						{
							// computation of Nk:
							double Nk = 0;
							ArrayList<Node> population = new ArrayList<Node>();
							for (int k = 0; k < nodes.size(); k++) 
								{
									if (nodes.get(k).permutPopID == popIDGstNst.get(j))
										{
											Nk = Nk + 1;
											population.add(nodes.get(k));
										}
								}
							// computation of Nki:
							double Nki = 0;
							for (int l = 0; l < population.size(); l++)
								{
									if (population.get(l).finalSequence.equals(sequence))
										{
											Nki = Nki + 1;
										}
								}
							Xki = Nki/Nk;
							double delta = 0;
							delta = (Xki - Xi);
							deltaX = deltaX + (delta*delta);
						}
				}
			
			Ht = 1 - X + (1/(n*(n-1)))*deltaX;
			Gst = 1 - (Hs/Ht);
			return Gst; 
		}
	
	// Method to compute the global Nst (Pons & Petit, 1996) on a permutated dataset:
	// (this method uses the "permutPopID" field instead of the "currentPop" field of the Node objects)
	public double globalPermutNst(ArrayList<Node> nodes)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			double Nh = 0;
			ArrayList<String> differentSequences1 = new ArrayList<String>();
			ArrayList<ArrayList<String>> differentSequences1ArrayList = new ArrayList<ArrayList<String>>();
			differentSequences1.add(nodes.get(0).finalSequence);
			differentSequences1ArrayList.add(nodes.get(0).sequence);
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).finalSequence.equals(nodes.get(j).finalSequence))
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							differentSequences1.add(nodes.get(i).finalSequence);
							differentSequences1ArrayList.add(nodes.get(i).sequence);
						}
				}
			Nh = differentSequences1.size();
			
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes.get(0).permutPopID));
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).permutPopID == nodes.get(j).permutPopID)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes.get(i).permutPopID)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}
			
			ArrayList<Integer> popIDGstNst = new ArrayList<Integer>(); // ArrayList popID's without ID's of populations containing only one individual
			for (int i = 0; i < popID.size(); i++)
				{
					double Nk = 0;
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popID.get(i))
								{
									Nk = Nk + 1;
								}
						}
					if (Nk > 1)
						{
							popIDGstNst.add(popID.get(i));
						}
				}
			
			double Nst = 0;
			double Vs = 0;
			double Vt = 0;
			double n = (double) popIDGstNst.size();
			// (3.1) computation of Vs:
			for (int i = 0; i < popIDGstNst.size(); i++)	
				{
					double Vk = 0;
					// computation of Nk:
					double Nk = 0;
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popIDGstNst.get(i))
								{
									Nk = Nk + 1;
									population.add(nodes.get(j));
								}
						} 
					// determination of the different alleles in the considered population: 
					ArrayList<String> differentSequences2 = new ArrayList<String>(); 
					ArrayList<ArrayList<String>> differentSequences2ArrayList = new ArrayList<ArrayList<String>>(); 
					differentSequences2.add(population.get(0).finalSequence);
					differentSequences2ArrayList.add(population.get(0).sequence);
					for (int j = 1; j < population.size(); j++)
						{
							int a = 0;
							for (int k = 0; k < j; k++)
								{
									if (population.get(j).finalSequence.equals(population.get(k).finalSequence))
										{
											a = a + 1;
										}
								}
							if (a == 0)
								{
									differentSequences2.add(population.get(j).finalSequence);
									differentSequences2ArrayList.add(population.get(j).sequence);
								}
						}
	
					// computation of Xx:
					double Xx = 0;
					for (int j = 1; j < differentSequences1.size(); j++)
						{
							for (int k = 0; k < j; k++)
								{
									if (differentSequences1.get(j).equals(differentSequences1.get(k)))
										{	}
									else 
										{
											// computation of Pi:					
											double a = 0;				
											double Pi = 0;
											ArrayList<String> sequence1 = new ArrayList<String>();
											ArrayList<String> sequence2 = new ArrayList<String>();
											sequence1 = differentSequences1ArrayList.get(j);
											sequence2 = differentSequences1ArrayList.get(k);
											for (int l = 0; l < sequence1.size(); l++)
												{
													if (sequence1.get(l).equals(sequence2.get(l)))
														{	}
													else 
														{
															a = a + 1;
														}
												}
											Pi = a/((double) sequence1.size());							
							
											// computation of the first Xki:
											double Nki1 = 0;
											double Xki1 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(j)))
														{
															Nki1 = Nki1 + 1;
														}
												}
											Xki1 = Nki1/Nk;									
							
											// computation of the second Xki:
											double Nki2 = 0;
											double Xki2 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(k)))
														{
															Nki2 = Nki2 + 1;
														}
												}
											Xki2 = Nki2/Nk;				
							
											Xx = Xx + (Pi*Xki1*Xki2);
										}
								}
						}
	
					Vk = (Nk/(Nk-1))*Xx;
					Vs = Vs + Vk;			
				}
			Vs = Vs/n;
	
			// (3.2) computation of Vt:
			double Vt1 = 0;									
			double Vt2 = 0;
			// computation of Vt1:
			for (int j = 1; j < (int) Nh; j++)
				{
					for (int k = 0; k < j; k++)
						{
							if (differentSequences1.get(j).equals(differentSequences1.get(k)))
								{	}
							else 
								{
									// computation of Pi:
									double a = 0;
									double Pi = 0;
									ArrayList<String> sequence1 = new ArrayList<String>();
									ArrayList<String> sequence2 = new ArrayList<String>();
									sequence1 = differentSequences1ArrayList.get(j);
									sequence2 = differentSequences1ArrayList.get(k);
									for (int l = 0; l < sequence1.size(); l++)
										{
											if (sequence1.get(l).equals(sequence2.get(l)))
												{	}
											else 
												{
													a = a + 1;
												}
										}
									Pi = a/((double) sequence1.size());							
				
									// computation of the first X.i:
									double Xi1 = 0;	
									for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
										{
											// computation of Nk:
											double Nk = 0;
											ArrayList<Node> population = new ArrayList<Node>();
											for (int l1 = 0; l1 < nodes.size(); l1++) 
												{
													if (nodes.get(l1).permutPopID == popIDGstNst.get(l2))
														{
															Nk = Nk + 1; 
															population.add(nodes.get(l1));
														}
												}																				
											// computation of Nki:
											double Nki = 0;
											for (int l1 = 0; l1 < population.size(); l1++)
												{
													if (population.get(l1).finalSequence.equals(differentSequences1.get(j)))
														{
															Nki = Nki + 1;
														}									
												} 
											Xi1 = Xi1 + (Nki/Nk);
										}
									Xi1 = Xi1/n;												
				
									// computation of the second X.i (X.j):
									double Xi2 = 0;	
									for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
										{
											// computation of Nk:
											double Nk = 0;
											ArrayList<Node> population = new ArrayList<Node>();
											for (int l1 = 0; l1 < nodes.size(); l1++) 
												{
													if (nodes.get(l1).permutPopID == popIDGstNst.get(l2))
														{
															Nk = Nk + 1;
															population.add(nodes.get(l1));
														}
												}
											// computation of Nki:
											double Nki = 0;
											for (int l1 = 0; l1 < population.size(); l1++)
												{
													if (population.get(l1).finalSequence.equals(differentSequences1.get(k)))
														{
															Nki = Nki + 1;
														}
												}
											Xi2 = Xi2 + (Nki/Nk);
										}
									Xi2 = Xi2/n;												
				
									Vt1 = Vt1 + (Pi*Xi1*Xi2);
								}
						}
				}
			// computation of Vt2:	
			for (int i = 0; i < popIDGstNst.size(); i++)
				{
					double Vt3 = 0;
					// computation of Nk:
					double Nk = 0;
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popIDGstNst.get(i))
								{
									Nk = Nk + 1;
									population.add(nodes.get(j));
								}
						}
					// determination of the different alleles in the considered population: 
					ArrayList<String> differentSequences2 = new ArrayList<String>(); 
					ArrayList<ArrayList<String>> differentSequences2ArrayList = new ArrayList<ArrayList<String>>(); 
					differentSequences2.add(population.get(0).finalSequence);
					differentSequences2ArrayList.add(population.get(0).sequence);
					for (int j = 1; j < population.size(); j++)
						{
							int a = 0;
							for (int k = 0; k < j; k++)
								{
									if (population.get(j).finalSequence.equals(population.get(k).finalSequence))
										{
											a = a + 1;
										}
								}
							if (a == 0)
								{
									differentSequences2.add(population.get(j).finalSequence);
									differentSequences2ArrayList.add(population.get(j).sequence);
								}
						}
	
					// computation of Vt2:
					for (int j = 1; j < differentSequences1.size(); j++)
						{
							for (int k = 0; k < j; k++)
								{
									if (differentSequences1.get(j).equals(differentSequences1.get(k)))
										{	}
									else 
										{
											// computation of Pi:
											double a = 0;					
											double Pi = 0;
											ArrayList<String> sequence1 = new ArrayList<String>();
											ArrayList<String> sequence2 = new ArrayList<String>();
											sequence1 = differentSequences1ArrayList.get(j);
											sequence2 = differentSequences1ArrayList.get(k);
											for (int l = 0; l < sequence1.size(); l++)
												{
													if (sequence1.get(l).equals(sequence2.get(l)))
														{	}
													else 
														{
															a = a + 1;
														}
												}
											Pi = a/((double) sequence1.size());  
							
											// computation of the first Xki:
											double Nki1 = 0;
											double Xki1 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(j)))
														{
															Nki1 = Nki1 + 1;
														}
												}
											Xki1 = Nki1/Nk;
							
											// computation of the second Xki:
											double Nki2 = 0;
											double Xki2 = 0;
											for (int l = 0; l < population.size(); l++)
												{
													if (population.get(l).finalSequence.equals(differentSequences1.get(k)))
														{
															Nki2 = Nki2 + 1;
														}
												}
											Xki2 = Nki2/Nk;
							
											// computation of the first X.i:
											double Xi1 = 0;	
											for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
												{
													// computation of Nkk:
													double Nkk = 0;
													ArrayList<Node> populationk = new ArrayList<Node>();
													for (int l1 = 0; l1 < nodes.size(); l1++) 
														{
															if (nodes.get(l1).permutPopID == popIDGstNst.get(l2))
																{
																	Nkk = Nkk + 1;
																	populationk.add(nodes.get(l1));
																}
														}
													// computation of Nkki:
													double Nkki = 0;
													for (int l1 = 0; l1 < populationk.size(); l1++)
														{
															if (populationk.get(l1).finalSequence.equals(differentSequences1.get(j)))
																{
																	Nkki = Nkki + 1;
																}
														}
													Xi1 = Xi1 + (Nkki/Nkk);
												}
											Xi1 = Xi1/n;
						
											// computation of the second X.i (X.j):
											double Xi2 = 0;	
											for (int l2 = 0; l2 < popIDGstNst.size(); l2++)
												{
													// computation of Nkk:
													double Nkk = 0;
													ArrayList<Node> populationk = new ArrayList<Node>();
													for (int l1 = 0; l1 < nodes.size(); l1++) 
														{
															if (nodes.get(l1).permutPopID == popIDGstNst.get(l2))
																{
																	Nkk = Nkk + 1;
																	populationk.add(nodes.get(l1));
																}
														}
													// computation of Nkki:
													double Nkki = 0;
													for (int l1 = 0; l1 < populationk.size(); l1++)
														{
															if (populationk.get(l1).finalSequence.equals(differentSequences1.get(k)))
																{
																	Nkki = Nkki + 1;
																}
														}
													Xi2 = Xi2 + (Nkki/Nkk);
												}
											Xi2 = Xi2/n;
											Vt3 = Vt3 + (Pi*(Xki1 - Xi1)*(Xki2 - Xi2));
										}
								}						
						}
					Vt2 = Vt2 + Vt3;
				}
			Vt = Vt1 - Vt2*(1/(n*(n-1)));
			Nst = 1 - (Vs/Vt);

			return Nst; 
		}
	
	// Method to compute the global Fst (Excoffier et al, 1992) on a permutated dataset:
	// (this method uses the "permutPopID" field instead of the "currentPop" field of the Node objects)
	public double globalPermutFst(ArrayList<Node> nodes, int length)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes.get(0).permutPopID));
			for (int i = 1; i < nodes.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes.get(i).permutPopID == nodes.get(j).permutPopID)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes.get(i).permutPopID)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}
			
			double Fst = 0;
			int locusLength = length;
			double n = (double) popID.size();
			double SSDwp = 0; // SSD "within populations"
			double SSDap = 0; // SSD "among populations"
			double nPrime = 0; // corresponds to (n')
			double MSDwp = 0; // MSD "within populations"
			double MSDap = 0; // MSD "among populations"
			double Oa = 0; // corresponds to (sigma)a^2
			double Ob = 0; // corresponds to (sigma)b^2
			double O = 0; // corresponds to (sigma)^2
			double N = 0; // number of tip nodes (number of sampled individuals)
			N = nodes.size();
			double ratioSum = 0; // cfr. green anotations
	
			// computation of SSDwp:
			for (int i = 0; i < n; i++)
				{
					double Nki = 0;
					double SSDwpp = 0;
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popID.get(i))
								{	
									Nki = Nki + 1;
									population.add(nodes.get(j));
								}
						}
					for (int j = 0; j < population.size(); j++)
						{
							for (int k = 0; k < population.size(); k++)
								{
									double Pij = 0;
									double a = 0;
									for (int l = 0; l < (int) locusLength; l++)
										{
											if (population.get(j).sequence.get(l).equals(population.get(k).sequence.get(l)) == false)
												{
													a = a + 1;
												}
										}
									Pij = a; //Pij = a/input.getLengthOfTheLocus();
									SSDwpp = SSDwpp + Pij;
								}
						}
					SSDwp = SSDwp + (SSDwpp/(2*Nki));
				}																				
	
			// computation of SSDap:
			double SSDap1 = 0;
			double Nkisum = 0;
			for (int i = 0; i < n; i++)
				{
					double Nki1 = 0;
					ArrayList<Node> population1 = new ArrayList<Node>();
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popID.get(i))
								{	
									Nki1 = Nki1 + 1;
									population1.add(nodes.get(j));
								}
						}
					Nkisum = Nkisum + (2*Nki1);
					for (int j = 0; j < Nki1; j++)
						{
							for (int k = 0; k < n; k++)
								{
									double Nki2 = 0;
									ArrayList<Node> population2 = new ArrayList<Node>();
									for (int l = 0; l < nodes.size(); l++) 
										{
											if (nodes.get(l).permutPopID == popID.get(k))
												{	
													Nki2 = Nki2 + 1;
													population2.add(nodes.get(l));
												}
										}
									for (int l = 0; l < Nki2; l++)
										{
											double Pij = 0;
											double a = 0;
											for (int m = 0; m < locusLength; m++)
												{
													if (population1.get(j).sequence.get(m).equals(population2.get(l).sequence.get(m)) == false)
														{
															a = a + 1;
														}
												}
											Pij = a; //Pij = a/input.getLengthOfTheLocus();
											SSDap1 = SSDap1 + Pij;
										}
								}
						}
				}
			SSDap1 = SSDap1/Nkisum;																					
	
			double SSDap2 = 0;
			SSDap2 = SSDwp;
	
			SSDap = SSDap1 - SSDap2;																					
	
			MSDwp = SSDwp/(N - n);																					
			MSDap = SSDap/(n-1);
			
			// computation of n':
			for (int i = 0; i < n; i++)
				{
					double Nki = 0;
					for (int j = 0; j < nodes.size(); j++) 
						{
							if (nodes.get(j).permutPopID == popID.get(i))
								{	
									Nki = Nki + 1;
								}
						}
					ratioSum = ratioSum + ((Nki*Nki)/N);
				}
			nPrime = ((N - ratioSum)/(n-1)); 																					
	
			Ob = MSDwp;																					
			Oa = (MSDap - Ob)/nPrime;																					
			O = Oa + Ob;																					
			Fst = Oa/O;

			return Fst; 
		}
	
	// Method to compute the distance (dgeo) between 2 populations from a "populations" ArrayList:
	public double populationsDistance(ArrayList<Population> populations0, int popID1, int popID2)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			double distance = -1;
			ArrayList<Population> populations = new ArrayList<Population>();
			populations = populations0;
			double[] position1 = new double[2]; double[] position2 = new double[2];
			position1 = populations.get(popID1).position;
			position2 = populations.get(popID2).position;
			distance = Math.sqrt(((position2[1]-position1[1])*(position2[1]-position1[1])) + ((position2[0]-position1[0])*(position2[0]-position1[0])));
			return distance; 
		}
	
	// Method to compute the Fst (Excoffier et al, 1992) between 2 populations from a "populations" ArrayList:
	public double populationsFst(Locus locus, ArrayList<Population> populations0, int popID1, int popID2)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			double Fst = -1;
			
			ArrayList<Node> nodes = new ArrayList<Node>();
			ArrayList<Population> populations = new ArrayList<Population>();
			populations = populations0;
			
			double n = (double) populations.size();
			ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID.add(Integer.valueOf(popID1 + 1)); popID.add(Integer.valueOf(popID2 + 1));
			
			double SSDwp = 0; // SSD "within populations"
			double SSDap = 0; // SSD "among populations"
			double nPrime = 0; // corresponds to (n')
			double MSDwp = 0; // MSD "within populations"
			double MSDap = 0; // MSD "among populations"
			double Oa = 0; // corresponds to (sigma)a^2
			double Ob = 0; // corresponds to (sigma)b^2
			double O = 0; // corresponds to (sigma)^2
			double N = 0; // number of tip nodes (number of sampled individuals)
			double P = 0; // number of sampled populations. 
			
			for (int i = 0; i < populations.size(); i++)
				{
					N = N + populations.get(i).nodes.size();
					nodes.addAll(populations.get(i).nodes);
				}
			P = populations.size();
			
			double ratioSum = 0; // cfr. green anotations

			// computation of SSDwp:
			for (int i = 0; i < n; i++)
				{
					double Nki = 0;
					double SSDwpp = 0;
					ArrayList<Node> population = new ArrayList<Node>();
					for (int j = 0; j < N; j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{	
									Nki = Nki + 1;
									population.add(nodes.get(j));
								}
						}
					for (int j = 0; j < population.size(); j++)
						{
							for (int k = 0; k < population.size(); k++)
								{
									double Pij = 0;
									double a = 0;
									for (int l = 0; l < (int) locus.length; l++)
										{
											if (population.get(j).sequence.get(l).equals(population.get(k).sequence.get(l)) == false)
												{
													a = a + 1;
												}
										}
									Pij = a; //Pij = a/input.getLengthOfTheLocus();
									SSDwpp = SSDwpp + Pij;
								}
						}
					SSDwp = SSDwp + (SSDwpp/(2*Nki));
				}																				

			// computation of SSDap:
			double SSDap1 = 0;
			double Nkisum = 0;
			for (int i = 0; i < n; i++)
				{
					double Nki1 = 0;
					ArrayList<Node> population1 = new ArrayList<Node>();
					for (int j = 0; j < N; j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{	
									Nki1 = Nki1 + 1;
									population1.add(nodes.get(j));
								}
						}
					Nkisum = Nkisum + (2*Nki1);
					for (int j = 0; j < Nki1; j++)
						{
							for (int k = 0; k < n; k++)
								{
									double Nki2 = 0;
									ArrayList<Node> population2 = new ArrayList<Node>();
									for (int l = 0; l < N; l++) 
										{
											if (nodes.get(l).currentPop == popID.get(k))
												{	
													Nki2 = Nki2 + 1;
													population2.add(nodes.get(l));
												}
										}
									for (int l = 0; l < Nki2; l++)
										{
											double Pij = 0;
											double a = 0;
											for (int m = 0; m < locus.length; m++)
												{
													if (population1.get(j).sequence.get(m).equals(population2.get(l).sequence.get(m)) == false)
														{
															a = a + 1;
														}
												}
											Pij = a; //Pij = a/input.getLengthOfTheLocus();
											SSDap1 = SSDap1 + Pij;
										}
								}
						}
				}
			SSDap1 = SSDap1/Nkisum;																					

			double SSDap2 = 0;
			SSDap2 = SSDwp;

			SSDap = SSDap1 - SSDap2;																					

			MSDwp = SSDwp/(N - P);																
			MSDap = SSDap/(P - 1);
			
			// computation of n':
			for (int i = 0; i < n; i++)
				{
					double Nki = 0;
					for (int j = 0; j < N; j++) 
						{
							if (nodes.get(j).currentPop == popID.get(i))
								{	
									Nki = Nki + 1;
								}
						}
					ratioSum = ratioSum + ((Nki*Nki)/N);
				}
			nPrime = ((N - ratioSum)/(P-1));	// NEW!!! 																					

			Ob = MSDwp;																					
			Oa = (MSDap - Ob)/nPrime;																					
			O = Oa + Ob;																					
			Fst = Oa/O;

			return Fst; 
		}
	
	// Method to compute the Fst (Excoffier et al, 1992) between 2 groups of populations:
	public double groupsPairwiseFst(Locus locus, Group group1, Group group2)
		{
			double Fst = -1;
			double SSDwp = 0; // SSD "within groups"
			double SSDap = 0; // SSD "among groups"
			double nPrime = 0; // corresponds to (n')
			double MSDwp = 0; // MSD "within groups"
			double MSDap = 0; // MSD "among groups"
			double Oa = 0; // corresponds to (sigma)a^2
			double Ob = 0; // corresponds to (sigma)b^2
			double O = 0; // corresponds to (sigma)^2
			double N = 0; // number of tip nodes (number of sampled individuals)
			double P = 2; // number of sampled groups
			
			ArrayList<Node> nodesFst = new ArrayList<Node>();
			ArrayList<Node> nodesInGroup1 = new ArrayList<Node>();
			ArrayList<Node> nodesInGroup2 = new ArrayList<Node>();
			ArrayList<ArrayList<Node>> nodesInGroups = new ArrayList<ArrayList<Node>>();
			
			ArrayList<Node> nodes = new ArrayList<Node>();
			for (int i = 0; i < locus.populations.size(); i++)
				{
					nodes.addAll(locus.populations.get(i).nodes);
				}
			
			for (int i = 0; i < group1.populations.size(); i++)
				{
					for (int j = 0; j < nodes.size(); j++)
					{
						if (group1.populations.get(i).popID == nodes.get(j).currentPop)
							{
								N = N + 1;
								nodesFst.add(nodes.get(j));
								nodesInGroup1.add(nodes.get(j));
							}
					}
				}
			for (int i = 0; i < group2.populations.size(); i++)
				{
					for (int j = 0; j < nodes.size(); j++)
					{
						if (group2.populations.get(i).popID == nodes.get(j).currentPop)
							{
								N = N + 1;
								nodesFst.add(nodes.get(j));
								nodesInGroup2.add(nodes.get(j));
							}
					}
				}
			nodesInGroups.add(nodesInGroup1); nodesInGroups.add(nodesInGroup2);
			
			double ratioSum = 0; // cfr. green anotations

			// computation of SSDwp:
			for (int i = 0; i < 2; i++)
				{
					double Nki = nodesInGroups.get(i).size();
					double SSDwpp = 0;
					for (int j = 0; j < nodesInGroups.get(i).size(); j++)
						{
							for (int k = 0; k < nodesInGroups.get(i).size(); k++)
								{
									double Pij = 0;
									double a = 0;
									for (int l = 0; l < locus.length; l++)
										{
											if (nodesInGroups.get(i).get(j).sequence.get(l).equals(nodesInGroups.get(i).get(k).sequence.get(l)) == false)
												{
													a = a + 1;
												}
										}
									Pij = a; //Pij = a/input.getLengthOfTheLocus();
									SSDwpp = SSDwpp + Pij;
								}
						}
					SSDwp = SSDwp + (SSDwpp/(2*Nki));
				}																				

			// computation of SSDap:
			double SSDap1 = 0;
			double Nkisum = 0;
			for (int i = 0; i < 2; i++)
				{
					double Nki1 = nodesInGroups.get(i).size();
					Nkisum = Nkisum + (2*Nki1);
					for (int j = 0; j < Nki1; j++)
						{
							for (int k = 0; k < 2; k++)
								{
									double Nki2 = nodesInGroups.get(k).size();
									for (int l = 0; l < Nki2; l++)
										{
											double Pij = 0;
											double a = 0;
											for (int m = 0; m < (int) locus.length; m++)
												{
													if (nodesInGroups.get(i).get(j).sequence.get(m).equals(nodesInGroups.get(k).get(l).sequence.get(m)) == false)
														{
															a = a + 1;
														}
												}
											Pij = a; //Pij = a/input.getLengthOfTheLocus();
											SSDap1 = SSDap1 + Pij;
										}
								}
						}
				}
			SSDap1 = SSDap1/Nkisum;																					

			double SSDap2 = 0;
			SSDap2 = SSDwp;

			SSDap = SSDap1 - SSDap2;																					

			MSDwp = SSDwp/(N - P);																		
			MSDap = SSDap/(P - 1);
			
			// computation of n':
			for (int i = 0; i < 2; i++)
				{
					double Nki = nodesInGroups.get(i).size();
					ratioSum = ratioSum + ((Nki*Nki)/N);
				}
			nPrime = ((N - ratioSum)/(P-1));																					

			Ob = MSDwp;																					
			Oa = (MSDap - Ob)/nPrime;																					
			O = Oa + Ob;																					
			Fst = Oa/O;

			return Fst; */
		}
}
