package spads1;

// Class created by Simon Dellicour (september 2012)

import java.util.ArrayList;

public class Permutations 
{
	public Permutations()
		{	}
	
	public ArrayList<Node> permutationsGlabalGstNstFst(ArrayList<Node> nodes)
		{
			ArrayList<Node> realNodes = new ArrayList<Node>();
			ArrayList<Node> permutationsNodes = new ArrayList<Node>();
			realNodes.addAll(nodes);
			permutationsNodes.addAll(nodes);		
			for (int i = 0; i < permutationsNodes.size(); i++)
				{
					int r = (int) (Math.random()*realNodes.size());
					int currentPop = realNodes.get(r).currentPop;
					permutationsNodes.get(i).permutPopID = currentPop;
					realNodes.remove(r);
				}	
			return permutationsNodes;
		}
	
	public ArrayList<Node> permutationsHaplotypes(ArrayList<Node> haplotypes)
		{
			ArrayList<Node> realHaplotypes = new ArrayList<Node>();
			ArrayList<Node> permutationsHaplotypes = new ArrayList<Node>();
			realHaplotypes.addAll(haplotypes);
			while(realHaplotypes.size() > 0)
				{
					int r = (int) (Math.random()*(realHaplotypes.size()-1));
					permutationsHaplotypes.add(realHaplotypes.get(r));
					// System.out.println("HapID: " + (realHaplotypes.get(r).haplotypeMismatchesIndex + 1));
					realHaplotypes.remove(r);
				}	// System.out.println();
			return permutationsHaplotypes;
		}
	
	public ArrayList<Node> permutationsAMOVAFsc(ArrayList<Node> nodes, ArrayList<Group> groups)
		{
			ArrayList<Node> realNodes = new ArrayList<Node>();
			ArrayList<Node> permutationsNodes = new ArrayList<Node>();
			realNodes.addAll(nodes);
			permutationsNodes.addAll(nodes);
			for (int i = 0; i < permutationsNodes.size(); i++)
				{
					boolean permutated = false;
					int g = -1;
					// (1) to determine in which group is the node i:
					for (int j = 0; j < groups.size(); j++)
						{
							for (int k = 0; k < groups.get(j).populations.size(); k++)
								{
									if (groups.get(j).populations.get(k).popID == permutationsNodes.get(i).currentPop)
										{
											g = j;
										}
								}
						}
					// (2) to find another node present in the same group:
					while (permutated == false)
						{	
							int r = (int) (Math.random()*realNodes.size());
							int currentPop = realNodes.get(r).currentPop;
							boolean inTheSameGroup = false;
							for (int j = 0; j < groups.get(g).populations.size(); j++)
								{
									if (groups.get(g).populations.get(j).popID == currentPop)
										{
											inTheSameGroup = true;
										}
								}
							if (inTheSameGroup == true)
								{
									permutationsNodes.get(i).permutPopID = currentPop;
									realNodes.remove(r);
									permutated = true;
								}
						}
				}
			return permutationsNodes;
		}
	
	public ArrayList<Group> permutationsAMOVAFct(ArrayList<Group> groups)
		{
			ArrayList<Group> permutationsGroups = new ArrayList<Group>();
			permutationsGroups.addAll(groups);
			ArrayList<Population> populationsBuffer = new ArrayList<Population>();
			// (1.1) creation of a "buffer" Arraylist having all the populations and
			// (1.2) initialization of the "permutPopulations" field of all groups:
			for (int i = 0; i < permutationsGroups.size(); i++)
				{
					populationsBuffer.addAll(groups.get(i).populations);
					permutationsGroups.get(i).permutPopulations = new ArrayList<Population>();
				}
			// (2) random filling of the "permutPopulations" field of all groups:
			for (int i = 0; i < permutationsGroups.size(); i++)
				{
					for (int j = 0; j < permutationsGroups.get(i).populations.size(); j++)
						{
							int r = (int) (Math.random()*populationsBuffer.size());
							permutationsGroups.get(i).permutPopulations.add(populationsBuffer.get(r));
							populationsBuffer.remove(r);
						}
				}			
			return permutationsGroups;
		}
}
